#!/bin/sh
# checkers/aadl/go.sh
# launch AADL rules checker
# Stood v5.0 - TNI-Europe - March 2005

# This file is executed by internalTools/external.sh

# arguments:
# $1 : this directory
# $2 : input file (prolog predicates)
# $3 : output file (extraction messages)

PREDICATS="$2"
export PREDICATS

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

# Launch checker:

echo "=== begin check : `date`"
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/_Input.sbp"
echo "=== end check : `date`"

DIR=`dirname "$3"`
for file in `ls $DIR` 
do
  if test ! -s $DIR/$file
    then rm $DIR/$file
  fi
done
