/*``utilities``Thu Sep  5 14:29:17 MET DST 1996``*/
/* getNIDN(X,I) */

getNIDN(X,I) :- getNID(X,J), getMaxNID(X,K), I is J / K.
/*``utilities``Wed Oct  9 13:00:30 MET 1996``*/
/* getNID(X,I) */

getNID(X,I) :- cpt2Rst, requires(_,_,X,_,'TYPE',X,W),
	( W='CstDef'; W='CstDef0'; W='CstDef1'; W='CstDef2'; W='OpDecl'; W='DataDef'; W='DataDef2' ), 
	cpt2Inc, fail.
getNID(X,I) :- cpt2Get(I).
 
/*``utilities``Wed Oct  9 13:17:51 MET 1996``*/
/* getMaxNID(X,I) */

getMaxNID(X,I) :- getND(X,J), getNPAR(X,K), getNDAT(X,L), 
	J1 is J - 1, J2 is J * J1, J3 is J2 / 2, I1 is J3 + K, I is I1 + L.
 
/*``utilities``Wed Oct  9 12:57:15 MET 1996``*/
/* getND(X,I) */

getND(X,I) :- cpt3Rst, 
	( isProvided(_,'TYPE',X); isProvided(_,'CONSTANT',X); isInternal(_,'TYPE',X); isInternal(_,'CONSTANT',X) ),
	cpt3Inc, fail.
getND(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Oct  9 12:57:11 MET 1996``*/
/* getNDAT(X,I) */

getNDAT(X,I) :- cpt3Rst, isInternal(_,'DATA',X), cpt3Inc, fail.
getNDAT(X,I) :- cpt3Get(I).
 
 
/*``utilities``Thu Sep  5 12:38:22 MET DST 1996``*/
/* getNPAR(X,I) */

getNPAR(X,I) :- cpt3Rst, 
	( argument(_,'OPERATION',X,_,_,_,_,_); return(_,'OPERATION',X,_,_) ),
	cpt3Inc, fail.
getNPAR(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Oct  9 13:53:48 MET 1996``*/
/* getNTYND(X,I) */

getNTYND(X,I) :- cpt2Rst, requires(_,_,X,_,'TYPE',Y,W), 
	Y\=X, notMemezTra(Y,'STANDARD'),
	( W='CstDef'; W='CstDef0'; W='CstDef1'; W='CstDef2'; W='OpDecl'; W='OpDef'; W='DataDef'; W='DataDef2' ), 
	cpt2Inc, fail.
getNTYND(X,I) :- cpt2Get(I).
/*``utilities``Wed Oct  9 13:54:01 MET 1996``*/
/* getNTYPND(X,I) */

getNTYPND(X,I) :- cpt2Rst, requires(_,_,X,_,'TYPE',Y,W), 
	memezTra(Y,'STANDARD'),
	( W='CstDef'; W='CstDef0'; W='CstDef1'; W='CstDef2'; W='OpDecl'; W='OpDef'; W='DataDef'; W='DataDef2' ), 
	cpt2Inc, fail.
getNTYPND(X,I) :- cpt2Get(I).
/*``utilities``Wed Oct  9 13:31:51 MET 1996``*/
/* memezTra(A,B) */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

notMemezTra(A,B) :- $name(A,L1), $name(B,L2), not(id(L1,L2)).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).
 
/*``interface``Wed Oct  9 13:43:15 MET 1996``*/
/* type-data dependencies : NID */

cohesion :- write('C O H E S I O N  :'), nl, nl,
	write('NUMBER OF TYPE-DATA DEPENDENCIES :'), nl, nl, cptRst,
	hoodObject(X,_,Y), not(hoodObject(_,_,X)), Y\='SYSTEM_CONFIGURATION',
	tab, write('NID-'), write(X), write(' = '),
	getNID(X,I), write(I), cptAdd(I), nl, fail.
cohesion :- tab, write('total NID : '), cptGet(I), write(I), nl, nl, fail.
/*``interface``Wed Oct  9 13:44:58 MET 1996``*/
/* normalized dependencies : NIDn */

cohesion :- write('NORMALIZED TYPE-DATA DEPENDENCIES :'), nl, nl, 
	hoodObject(X,_,Y), not(hoodObject(_,_,X)), Y\='SYSTEM_CONFIGURATION', 
	tab, write('ND-'), write(X), write(' = '), getND(X,I), write(I), nl, 
	tab, write('NPAR-'), write(X), write(' = '), getNPAR(X,J), write(J), nl,
	tab, write('NDAT-'), write(X), write(' = '), getNDAT(X,K), write(K), nl,
	tab, tab, write('maxNID-'), write(X), write(' = '), getMaxNID(X,L), write(L), nl, nl, fail.
 
/*``interface``Wed Oct  9 13:47:51 MET 1996``*/
/* external user-defined types used : NTYND */

cohesion :- nl, write('EXTERNAL USER DEFINED TYPES USED :'), nl, nl, cptRst,
	hoodObject(X,_,Y), not(hoodObject(_,_,X)), Y\='SYSTEM_CONFIGURATION', 
	tab, write('NTYND-'), write(X), write(' = '),
	getNTYND(X,I), write(I), cptAdd(I), nl, fail.
cohesion :- tab, write('total NTYND : '), cptGet(I), write(I), nl, nl, fail.
/*``interface``Wed Oct  9 13:47:58 MET 1996``*/
/* external pre-defined types used : NTYPND */

cohesion :- nl, write('EXTERNAL PREDEFINED TYPES USED :'), nl, nl, cptRst,
	hoodObject(X,_,Y), not(hoodObject(_,_,X)), Y\='SYSTEM_CONFIGURATION', 
	tab, write('NTYPND-'), write(X), write(' = '),
	getNTYPND(X,I), write(I), cptAdd(I), nl, fail.
cohesion :- tab, write('total NTYND : '), cptGet(I), write(I), nl, nl, fail.
 
