/*``Always first loaded``Wed Oct  9 10:59:12 MET 1996``*/
/* stood v4 */
/*  main program : */

go :- 
	$init_sys,
	$getenv('PREDICATS',File),
	$consult(File),
	check, fail.

check :- check(N,R,S), memezTra(N,'Size'), 
	$loadqual(R,0), $tell(S); size, fail; $told.
check :- check(N,R,S), memezTra(N,'Depth'), 
	$loadqual(R,0), $tell(S); depth, fail; $told.
check :- check(N,R,S), memezTra(N,'Other'), 
	$loadqual(R,0), $tell(S); other, fail; $told.
check :- check(N,R,S), memezTra(N,'Coupling'), 
	$loadqual(R,0), $tell(S); coupling, fail; $told.
check :- check(N,R,S), memezTra(N,'Cohesion'), 
	$loadqual(R,0), $tell(S); cohesion, fail; $told.
/*``macro``Mon Mar 18 17:03:43 MET 1996``*/
/* counter 1 */

cptRst :- $globalset(cpt(0)).
cptPut(I) :- $globalset(cpt(I)).
cptGet(I) :- cpt(I).
cptInc :- cpt(I), J is I + 1, $globalset(cpt(J)).
cptDec :- cpt(I), J is I - 1, $globalset(cpt(J)).
cptAdd(I) :- cpt(J), K is J + I, $globalset(cpt(K)).
cptSub(I) :- cpt(J), K is J - I, $globalset(cpt(K)).
cptMul(I) :-  cpt(J), K is J * I, $globalset(cpt(K)).
cptDiv(I) :- cpt(J), K is J // I, $globalset(cpt(K)).
cptNeg :- cpt(I), J is -I, $globalset(cpt(J)).

/*``macro``Mon Mar 18 17:25:35 MET 1996``*/
/* counter 2 */

cpt2Rst :- $globalset(cpt2(0)).
cpt2Put(I) :- $globalset(cpt2(I)).
cpt2Get(I) :- cpt2(I).
cpt2Inc :- cpt2(I), J is I + 1, $globalset(cpt2(J)).
cpt2Dec :- cpt2(I), J is I - 1, $globalset(cpt2(J)).
cpt2Add(I) :- cpt2(J), K is J + I, $globalset(cpt2(K)).
cpt2Sub(I) :- cpt2(J), K is J - I, $globalset(cpt2(K)).
cpt2Mul(I) :-  cpt2(J), K is J * I, $globalset(cpt2(K)).
cpt2Div(I) :- cpt2(J), K is J // I, $globalset(cpt2(K)).
cpt2Neg :- cpt2(I), J is -I, $globalset(cpt2(J)).

/*``macro``Mon Mar 18 17:25:03 MET 1996``*/
/* counter 3 */

cpt3Rst :- $globalset(cpt3(0)).
cpt3Put(I) :- $globalset(cpt3(I)).
cpt3Get(I) :- cpt3(I).
cpt3Inc :- cpt3(I), J is I + 1, $globalset(cpt3(J)).
cpt3Dec :- cpt3(I), J is I - 1, $globalset(cpt3(J)).
cpt3Add(I) :- cpt3(J), K is J + I, $globalset(cpt3(K)).
cpt3Sub(I) :- cpt3(J), K is J - I, $globalset(cpt3(K)).
cpt3Mul(I) :-  cpt3(J), K is J * I, $globalset(cpt3(K)).
cpt3Div(I) :- cpt3(J), K is J // I, $globalset(cpt3(K)).
cpt3Neg :- cpt3(I), J is -I, $globalset(cpt3(J)).

/*``macro``Thu Aug  4 11:26:38 MET DST 1994``*/
/* user interface */

write(T) :- $writename(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
nl :- $put(10).
tab :- $put(9).
sp :- $put(32).

/*``macro``Wed Sep  4 17:31:42 MET DST 1996``*/
/* hood interface */

hoodObject(X,T,Z) :- isObject(X,T,Z), 
	X \= 'SYSTEM_DIAGRAM', X \= 'SYSTEM_CONFIGURATION', 
	X \= 'FORMAL_PARAMETERS'.

brothers(X,Y) :- hoodObject(X,_,Z), hoodObject(Y,_,Z), X \= Y.

uncle(X,Y) :- hoodObject(X,_,Z), brothers(Z,Y), not(env(Y)), not(hoodObject(Y,_,'SYSTEM_CONFIGURATION')).

env(X) :- isRootObject(X,'DESIGN',_), not(isCurrentRoot(X)).

isNotTerm(Y) :-  hoodObject(_,_,Y), !.

isTerm(Y) :- hoodObject(Y,_,_), not(hoodObject(_,_,Y)).

hasParameter(U,X) :- return(U,'OPERATION',X,_,_,_), !.
hasParameter(U,X) :- argument(U,'OPERATION',X,_,_,_,_,_,_), !.
/*``macro``Thu Aug  4 11:25:42 MET DST 1994``*/
/* miscalleneous */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

$member2(X,L) :- nonvar(L), L = [Y|Z], (X = Y ; $member2(X,Z)).

return(U,'OPERATION',X,_,_) :- return(U,'OPERATION',X,_,_,_).
argument(U,'OPERATION',X,_,_,_,_,_) :- argument(U,'OPERATION',X,_,_,_,_,_,_).
