/* Entity-References Matrix */
/* 21 July 2000 */
/* (cf. RASTO/00.004) 07 December 2000 */
/* (cf. RASTO/03.015) 14 February 2003 */

erm :- nl, write('ENTITIES-REQUIREMENTS MATRIX'), nl, nl, 
	hoodObject(X,_,_), not(env(X)), nl, 
	write('In Module: '), write(X), nl, write('----------------'), nl, 
	entity(U,E,X), convert(E,_,T,_), writeEntity(U,T,X),  
	( ( coversRequirement(_,W,X,U), convert(E,_,_,W) ) -> nl; ( tab, write('NONE'), nl ) ), 
	coversRequirement(R,S,X,U), convert(E,_,_,S), 
	tab, write(R), write(' ('), writeSection(S), write(')'), nl. 

entity(U,E,X) :- isProvided(U,E,X); isInternal(U,E,X).
entity(U,'STATE',X) :- isState(X,U,_).
entity(U,'TRANSITION',X) :- isTransition(X,U,_,_,_).
entity('NIL','NIL',X).

writeEntity(U,T,X) :- U \= 'NIL', write(T), sp, write(X), dot, write(U), write(' covers:').
writeEntity('NIL',_,X) :- write('Other sections cover:').
