#!/bin/sh
# code_extractors/aadl/go.sh
# launch AADL code extractor
# Stood v5.0 - TNI Europe - March 2005

# This file is executed by internalTools/external.sh

# arguments:
# $1 : this directory
# $2 : input file (prolog predicates)
# $3 : output file (extraction messages)

PREDICATS="$2"
export PREDICATS

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH

# Launch code generator:

echo "=== begin code extraction : `date`"
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$1/Input.sbp"
echo "=== end code extraction : `date`"
