#ifndef INCLUDE_process
#define INCLUDE_process
typedef int Process;
Process *ProcAlloc(void(*func) (), int wsize, int param_words, ...);
void ProcRun(Process *p);
void ProcRunHigh(Process *p);
void ProcRunLow(Process *p);
int ProcJoinList(Process **p);
void ProcAllocClean(Process *p);
int ProcAlt(Channel *c1, ...);
int ProcTimerAlt(int time, Channel *c1, ...);
int ProcTime(void);
int ProcTimePlus(const int time1, const int time2);
int ProcInit(Process *p, void(*func) (), int *ws, int wsize, int param_words, ...);
void ProcInitClean(Process *p);
#endif
