//-------------------------------------------
//  Stood v4
//  HoodLine.java for html doc generator
//
//  Copyright TNI 1997
//  Pierre DISSAUX (pierre.dissaux@tni.fr)
//  last release : 07/97
//-------------------------------------------

import java.awt.Color;
import java.awt.Graphics;
import java.io.*;

class HoodLine {
	String label1;
	String label2;
	String label;
        int linetype, scale;   
	int x1, x2, x3, x4;
	int y1, y2, y3, y4;
	public HoodLine(String l1,String nom_ext,int xx1,int yy1,int xx2,int yy2,int xx3,int yy3,int xx4,int yy4, String Lb,int scalei,int type_lg) {

		label1 = l1;
		label = Lb;
                linetype = type_lg;
                scale = scalei; 
		label2 = nom_ext;
		x1 = xx1;
		x2 = xx2;
		x3 = xx3;
		x4 = xx4;
		y1 = yy1;
		y2 = yy2;
		y3 = yy3;
		y4 = yy4;
	}
	public void drawl(Graphics g,Color fg,Color bg,Color drawlinecolor) {
                int nbstring, nbst;
                int valstring, valst;
		g.setColor(fg);
		g.setColor(drawlinecolor);
		g.drawLine(x1,y1,x2,y2);
		g.drawLine(x2,y2,x3,y3);
		g.drawLine(x3,y3,x4,y4);
                /* afficher les fleches */
                if (linetype == 1) {
                  
                  if ((y3 == y4)) {
                    if (x3 < x4) {
                      g.drawLine(x4-6,y4+4,x4,y4);
                      g.drawLine(x4-6,y4-4,x4,y4);
                    }
                    else {
                      g.drawLine(x4+6,y4+4,x4,y4);
                      g.drawLine(x4+6,y4-4,x4,y4);
                    }
                  }
                  else if ((x3 == x4)) {
                    if (y3 < y4) {
                      g.drawLine(x4-6,y4-4,x4,y4);
                      g.drawLine(x4+6,y4-4,x4,y4);
                    }
                    else {
                      g.drawLine(x4-6,y4+4,x4,y4);
                      g.drawLine(x4+6,y4+4,x4,y4);
                    }
                  }
               }
               else if (linetype == 2) {
                  /* cas de fleche ferme */
                  if ((y3 == y4)) {
                    if (x3 < x4) {
                      g.setColor(bg);
                      g.fillRect(x4-6,y4-6,6,8);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4-6,y4-6,x4-6,y4+6);
                      g.drawLine(x4-6,y4+6,x4,y4);
                      g.drawLine(x4-6,y4-6,x4,y4);
                    
                    }
                    else {
                      g.setColor(bg);
                      g.fillRect(x4+6,y4-6,6,8);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4+6,y4-6,x4+6,y4+6);
                      g.drawLine(x4+6,y4+6,x4,y4);
                      g.drawLine(x4+6,y4-6,x4,y4);
                    }
                  }
                  else if ((x3 == x4)) {
                    if (y3 < y4) {
                      g.setColor(bg);
                      g.fillRect(x4-6,y4-6,12,6);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4-6,y4-6,x4+6,y4-6);
                      g.drawLine(x4-6,y4-6,x4,y4);
                      g.drawLine(x4+6,y4-6,x4,y4);
                    }
                    else {
                      g.setColor(bg);
                      g.fillRect(x4-6,y4-6,12,6);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4-6,y4+6,x4+6,y4+6);
                      g.drawLine(x4-6,y4+6,x4,y4);
                      g.drawLine(x4+6,y4+6,x4,y4);
                    }
                  }
               }
               else if (linetype == 3) {
                  /* cas de fleches lousange */
                  if ((y3 == y4)) {
                    if (x3 < x4) {
                      g.setColor(bg);
                      g.fillRect(x4-10,y4-5,10,10);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4-5,y4+5,x4,y4);
                      g.drawLine(x4-5,y4-5,x4,y4);
                      g.drawLine(x4-10,y4,x4-5,y4+5);
                      g.drawLine(x4-10,y4,x4-5,y4-5);
                    }
                    else {
                      g.setColor(bg);
                      g.fillRect(x4+10,y4-5,10,-10);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4+5,y4+5,x4,y4);
                      g.drawLine(x4+5,y4-5,x4,y4);
                      g.drawLine(x4+5,y4+5,x4+10,y4);
                      g.drawLine(x4+5,y4-5,x4+10,y4);
                    }
                  }
                  else if ((x3 == x4)) {
                    if (y3 < y4) {
                      g.setColor(bg);
                      g.fillRect(x4-5,y4-10,10,10);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4-5,y4-5,x4,y4);
                      g.drawLine(x4+5,y4-5,x4,y4);
                      g.drawLine(x4,y4-10,x4-5,y4-5);
                      g.drawLine(x4,y4-10,x4+5,y4-5);
                    }
                    else {
                      g.setColor(bg);
                      g.fillRect(x4-5,y4,10,10);
                      g.setColor(drawlinecolor);
                      g.drawLine(x4,y4,x4-5,y4+5);
                      g.drawLine(x4,y4,x4+5,y4+5);
                      g.drawLine(x4-5,y4+5,x4,y4+10);
                      g.drawLine(x4+5,y4+5,x4,y4+10);
                    }
                  }
               }
               if (linetype != -1) { 
                int valstring2, h = 14;
                int radius = 3 ;
                nbstring = label2.length();
                valstring = 100/12 * nbstring;
                valstring2 = valstring / 2;

                 /*ajouter les objets exterieur et label */
                if ((x1 == x2) && (x2 == x3) && (x3 == x4)) {
                  if (y1 < y2) {
                    g.setColor(bg);
                    g.fillRoundRect(x1-valstring2,y4,valstring,14,radius,radius);
                    g.setColor(fg);
                    g.drawRoundRect(x1-valstring2,y4,valstring,14,radius,radius);
                    g.drawString(label2,x1-valstring2+5,y4+10);
                  }
                  else {
                    g.setColor(bg);
                    g.fillRoundRect(x1-valstring2,y4-14,valstring,14,radius,radius);
                    g.setColor(fg);
                    g.drawRoundRect(x1-valstring2,y4-14,valstring,14,radius,radius);
                    g.drawString(label2,x1-valstring2+5,y4-5);
                  }
                }
                else if ((y1 == y2) && (y2 == y3) && (y3 == y4) && (x4 > x1)) {
                  g.setColor(bg);
                  g.fillRoundRect(x4,y4-7,valstring,14,radius,radius);
                  g.setColor(fg);
                  g.drawRoundRect(x4,y1-7,valstring,14,radius,radius);
                  g.drawString(label2,x4+2,y1+5);
                } 
               }
               /* afficher des etiquettes en liens */
               if (label.compareTo("NONE") != 0) {
                 if (y2 == y3) {
                   g.drawString(label,x2+(x3-x2)/4,y2-5);
                 }
                 else {
                   g.drawString(label,x2+4,y2+(y3-y2)/4);
                 }
               }

	}
}

