#!/bin/sh
# doc_extractors/mif/print.sh
# FrameMaker doc generator (prolog)
# Stood v4.3 - TNI - December 2002

# This file is executed by internalTools/print.sh

# arguments:
# $1 : input file (prolog predicates)
# $2 : this directory

NOMTAG='TNI'
PREDICATS="$1"

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH PREDICATS NOMTAG

echo "=== begin doc generation : `date`"
cp "$1" `dirname "$1"`/extract.pro
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$2/Input.sbp"
cat "$2/header.mif" "$1" > "$1_tmp"
mv "$1_tmp" "$1"
echo "=== end doc generation : `date`"

