#!/bin/sh
# doc_extractors/tps/print.sh
# Interleaf doc generator (prolog)
# Stood v4.3 - TNI - December 2002

# This file is executed by internalTools/print.sh

# arguments:
# $1 : input file (prolog predicates)
# $2 : this directory

HEADER="$2/header.tps"
PREDICATS="$1"
TPSFILE="$1"
NOMTAG=TNI
SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export HEADER PREDICATS NOMTAG TPSFILE SIMPATH

echo "=== begin doc generation : `date`"
cp "$1" `dirname "$1"`/extract.pro
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$2/Input.sbp"
echo "=== end doc generation : `date`"

