#!/bin/sh
# STOOD v4.3 - TNI - December 2002 -
# check_ada : syntactic ada95 check with gnat.

SECTION="$5"
FILE=`echo "$1" | sed 's/.*\///'`
DIR=`echo "$1" | sed 's/\/[^\/]*$//'`
NAME=`echo "$1" | sed 's/\.[^\.]*$//'`
SUFFIX=`echo "$1" | sed 's/.*\.//'`

# path to compiler:
PATH=$ADA_PATH:$PATH; export PATH

case $SUFFIX in
	ads) 
		gcc -c -gnatcv $1
		exit;;
	adb)
		gcc -c -gnatcv $1
		exit;;
esac
# create a temporary file and unit:
echo "package body temp is" > temp.adb
cat "$1" >> temp.adb
echo >> temp.adb
echo "end temp;" >> temp.adb
gcc -c -gnatsv temp.adb
rm temp.adb

