#!/bin/sh
# internalTools/copyunlock.sh
# unlock a version with the system configuration manager
# Stood 5.0 - TNI Europe - June 2004

# This file is executed to unlock the version within CM space.
# It is called from the menus:
# Design/checkin and Component/checkin.
# echo unlock

# arguments:
# echo $1 : current design
# echo $2 : base directory
# echo $3 : version id
# echo $4 : selected component
# echo $5 : lock flag
# echo $6 : filename with the list of components 
# when the property CheckInWithArgFile is set to Yes

if test -z $3
then V=Default
else V=$3
fi

cd $2

if test $1 = $4
then
  if test -f $V/$1/StoodCM.lok
  then rm $V/$1/StoodCM.lok
  fi
fi
