#!/bin/sh
# internalTools/cvsout.sh
# checkout from CVS
# Stood v4.3 - TNI - December 2002

# This file is executed when a module is loaded.
# echo checkout
 
# arguments:
# echo $1 : name of design
# echo $2 : base directory of the design
# echo $3 : version id
# echo $4 : selected module
# echo $5 : protection flag

CVSROOT=:ext:tni@popoff:/home/popoff/cvs
export CVSROOT

cd $2

if test $1 = $4 # Module load or Design load ?
then
	directoryToCheckout=$1
else
	directoryToCheckout=$1/$4
fi

if test ! $3 == '' # Version is defined ?
then
	version='-r '$3
	string='revision '$3' of'
fi
if test $5 == 'ro'
then
	$CONFIG/internalTools/lock.sh Stood.lok $1
fi

echo 'check out '$string' design '$1' from repository to local space'

if test -d .temporary.$1
then
	rm -rf .temporary.$1
fi

if `cvs -Q checkout -d .temporary.$1 $version $1`
then
	rm -rf directoryToCheckout
	mv .temporary.$1 directoryToCheckout
fi
	
	