----------------------------------
C type declaration:
----------------------------------

type_declaration ::=
	typedef type_definition $Ob__$Tp;

type_definition ::=
	predefined_type_ref
	$Ob__local_type_ref
	| remote_module__remote_type_ref
	| struct { t1 a1; t2 a2; }
	| enum { e1, e2, e3 }
	| union { t1 v1; t2 v2; }

Notes:
----
- All component reference should use module name prefix
in order to manage name spaces and HOOD visibility rules