The DriverModeLogic component is an AADL Thread with a Periodic Dispatch_Protocol property. It may be modeled either by an HRT Cyclic Object or by a regular Active Object calling AADL services. Here, we chose the former.
This component offers the same interface as the parent Process, and "delegate" relationships represent the connexions between the two interfaces. Note that the direction of the arrow is always top-down even for Out Ports.

In the internals of the component, the following entities have been defined:
- an operation called "thread" (created automatically for cyclic and sporadic Objects)
- a structured type, called "Port_Type" whose attributes map the Data Ports name and type
- a local variable of this type called "Port_Value" to store the Data Ports.