{ 
  int running = 1;
  motor__modes current_order = stopped;
  while (running)
  { 
    current_order = user_interface__check_orders();
    switch (current_order)
    { 
      case stopped : 
      {
        motor__switch_off();
        display_unit__display_speed("off");
        display_unit__display_status("off");
        heater__turn_off();
      }
      case low :
      {
        motor__switch_low();
        display_unit__display_speed("low");
        display_unit__display_status("on");
        cycle_heater();
      }
      case high:
      {
        motor__switch_high();
        display_unit__display_speed("high");
        display_unit__display_status("on");
        cycle_heater();
      }
    }
  }
}