// BODY OF MODULE : ListManager
// ========== visibility on specification file : 
#include "ListManager.h"
// ========== visibility on required modules : 
#include "../../libraryClasses/_cpp/libraryClasses.h"
#include <stream.h>
// ---------- provided operation bodies : 
ListManager::ListManager()
{
	the_list = new List;
}

void ListManager::perform(const int action)
{
	switch (action) {
	case 1 : add(); break;
	case 2 : show(); break;
	case 3 : make_sorted(1); break;
	case 4 : make_sorted(0); break;
	case 5 : make_sorted(-1); break;
	case 6 : add_random(); break;
	case 7 : make_arrayed(); break;
	default : ;
	}
}

// ---------- internal operation bodies : 
void ListManager::make_sorted(const int up)
{
	List *new_list;
	switch (up) {
	case 1 : new_list = new SortedList(1); break;
	case 0 : new_list = new SortedList(0); break;
	case -1 : new_list = new List(); break;
	};
	Iterator &i = the_list->getIterator();
	while (i.more())
		new_list->insert(i.next());
	the_list = new_list;
}

void ListManager::add()
{
	int new_one;
	cout << "Enter a number : ";
	cin >> new_one;
	the_list->insert(new_one);
}

void ListManager::show()
{
	Iterator &i = the_list->getIterator();
	cout << "The list : \n";
	while (i.more())
		cout << i.next() << "\n";
	cout << "\n";
}

void ListManager::add_random()
{
	the_list->insert(35);
	the_list->insert(7);
	the_list->insert(9024);
	the_list->insert(12);
}

void ListManager::make_arrayed()
{
	Iterator &i = the_list->getIterator();
	the_list = new ArrayedList;
	while (i.more())
		the_list->insert(i.next());
}

// END OF MODULE : ListManager
