--  visibility on required modules : 
with instr;
use type instr.Clock;
package clocks.accurate_clocks is
  subtype Thousand is Integer range 0 .. 1000;
  type Accurate_Clock is new Clock with 
  record 
    MilliSec : Thousand := 0;
  end record;
  procedure Display_Value (me : IN Accurate_Clock);
  procedure Increment (me : IN OUT Accurate_Clock; inc : IN Integer := 1);
--  Subprogram : Init is inherited from : Instrument
end clocks.accurate_clocks;
