--  visibility on required modules : 
with gnat.io;
 use gnat.io;
--  visibility on objects required by nested operation bodies : 
package body clocks.accurate_clocks is
  package io renames gnat.io;
  procedure Display_Value (me : IN Accurate_Clock) is
  begin 
        Display_Value (Clock (me));
        Put (":"); 
        Put (Character'Val (Character'Pos ('0') + (me.MilliSec / 100) mod 10));
        Put (Character'Val (Character'Pos ('0') + (me.MilliSec / 10) mod 10));
        Put (Character'Val (Character'Pos ('0') + me.MilliSec mod 10));
  end Display_Value;
  procedure Increment (me : IN OUT Accurate_Clock; inc : IN Integer := 1) is
  begin
       Increment (Clock (me), (me.MilliSec + Inc) / 1000);
       me.MilliSec := (me.MilliSec + Inc) mod 1000;
  end Increment;
end clocks.accurate_clocks;
