--  visibility on required modules : 
package body gen_list is
  function Append (E1 : IN Elmt) return pList is
  begin
  	return new List'(E1,Nil);
  end Append;
  function Append (E1 : IN Elmt; E2 : IN Elmt) return pList is
  begin
  	return new List'(E1, new List'(E2,Nil));
  end Append;
  function Append (E1 : IN Elmt; L1 : IN pList) return pList is
  begin
  	return new List'(E1,L1);
  end Append;
  function Append (L1 : IN pList; E1 : IN Elmt) return pList is
  	L : pList;
  begin
  	if L1 = Nil then
  		return new List'(E1,Nil);
  	else
  		L := L1;
  		while L.Next /= Nil loop
  			L := L.Next;
  		end loop;
  		L.Next := new List'(E1,Nil);
  		return L1;
  	end if;
  end Append;
  function Append (L1 : IN pList; L2 : IN pList) return pList is
  	L : pList;
  begin
  	if L1 = Nil then
  		return L2;
  	else
  		L := L1;
  		while L.Next /= Nil loop
  			L := L.Next;
  		end loop;
  		L.Next := L2;
  		return L1;
  	end if;
  end Append;
  function Element (L : IN pList; Number : IN Positive := 1) return Elmt is
  	L1 : pList := L;
  begin
  	for I in 2 .. Number loop
  		if L1 = Nil then
  			raise Error_List;
  		end if;
  		L1 := L1.Next;
  	end loop;
  	return L1.E;
  end Element;
  function Tail (L : IN pList; Skip : IN Positive := 1) return pList is
  	L1 : pList := L;
  begin
  	for I in 1 .. Skip loop
  		if L1 = Nil then
  			raise Error_List;
  		end if;
  		L1 := L1.Next;
  	end loop;
  	return L1;
  end Tail;
  function Length (L : IN pList) return Natural is
  	C : Natural := 0;
  	L1 : pList := L;
  begin
  	while L1 /= Nil loop
  		C := C + 1;
  		L1 := L1.Next;
  	end loop;
  	return C;
  end Length;
end gen_list;
