Dining room behaviour is represented by a State Transition model and constraints on operation execution requests:

BR5: Dining room has two distinct states:
- waiting state, identified by internal state variable "started" set to FALSE, where Room may only receive "Start_Serving" execution requests.
- dining state, identified by internal state variable "started" set to TRUE, where Room may only receive "Report_State" execution requests.

BR3: Start_Serving has an asynchronous execution request (ASER).

BR4: Report_State has a highly synchronous execution request (HSER), so that Philosopher 's internal state doesn't change while current state is displayed on relevant window.