--  visibility on required modules : 
with Ada.Real_Time; use Ada.Real_Time;
with RTA; use RTA;
--  visibility on real_time attributes : 
with ch4_status_RTATT;
package ch4_status is
  type methane_status is (Motor_safe, Motor_Unsafe);
  protected OBCS is
    pragma PRIORITY(ch4_status_RTATT.INITIAL_CEILING_PRIORITY);
    procedure write (Current_status : IN methane_status);
    function read return methane_status;
  private
  end OBCS;
  procedure write (Current_status : IN methane_status) renames OBCS.write;
  function read return methane_status renames OBCS.read;
end ch4_status;
