--  visibility on required modules : 
--  visibility on implementing modules : 
with hl_water_sensor;
use type hl_water_sensor.water_mark;
with motor;
use type motor.pump_status;
use type motor.motor_state_changes;
with water_flow_sensor;
use type water_flow_sensor.water_flow;
--  visibility on real_time attributes : 
with pump_controller_RTATT;
package pump_controller is
  subtype water_mark is hl_water_sensor.water_mark;
  subtype pump_status is motor.pump_status;
  subtype motor_state_changes is motor.motor_state_changes;
  subtype water_flow is water_flow_sensor.water_flow;
  pump_not_safe : exception renames motor.pump_not_safe;
  procedure not_safe renames motor.not_safe;
  procedure is_safe renames motor.is_safe;
  function request_status return pump_status renames motor.request_status;
  procedure set_pump (status : IN pump_status) renames motor.set_pump;
end pump_controller;
