with SYSTEM; use SYSTEM;
with RTA; use RTA;
with Ada.Real_Time; use Ada.Real_Time;
package water_flow_sensor_RTATT is
  initialise : constant array(SYSTEM_WIDE_MODE) of OPERATION_ATTRIBUTES := 
    ( others => ( 
      BUDGET => To_Time_Span(0.0),
      WCET => To_Time_Span(0.0) ) );
  CEILING : constant array(SYSTEM_WIDE_MODE) of PRIORITY := 
    ( others => 0 );
  INITIAL_CEILING_PRIORITY : constant PRIORITY := CEILING(START_MODE);
  THREAD : constant array(SYSTEM_WIDE_MODE) of THREAD_ATTRIBUTES := 
    ( others => ( 
      PRI => 9,
      TRANS => To_Time_Span(0.0),
      IMP => soft,
      DEADLINE => To_Time_Span(40.000000),
      BUDGET => To_Time_Span(0.0),
      WCET => To_Time_Span(10.000000) ) );
  INITIAL_THREAD_PRIORITY : constant PRIORITY := THREAD(START_MODE).PRI;
  PERIOD : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := 
    ( others => To_Time_Span(1000.000000) );
  OFFSET : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := 
    ( others => To_Time_Span(0.0) );
end water_flow_sensor_RTATT;
