/* Begin Spec of cyclic                                                       */
#ifndef INCLUDE_cyclic
#define INCLUDE_cyclic
/* ---------- include real-time libraries: ---------------------------------- */
#include <stdio.h>
#include <stdlib.h>
#include <channel.h>
#include <process.h>

/* ---------- provided operations: ------------------------------------------ */
extern void cyclic__start(void);

extern void cyclic__timer(void);

extern void cyclic__stop(void);

/* ---------- obcs specification: ------------------------------------------- */

/*  OBCS init, exec and termination procedures:                               */
Process * cyclic__OBCS_init(void);
void cyclic__OBCS_proc(Process * cyclic__OBCS);
void cyclic__OBCS_stop(void);
void cyclic__OBCS_term(void);

/* End Spec of cyclic                                                         */
#endif
