/* Begin Spec of server                                                       */
#ifndef INCLUDE_server
#define INCLUDE_server
/* ---------- include required interface: ----------------------------------- */
#include "shared.h"
/* ---------- include real-time libraries: ---------------------------------- */
#include <stdio.h>
#include <stdlib.h>
#include <channel.h>
#include <process.h>

/* ---------- provided operations: ------------------------------------------ */
extern void server__op1(shared__T_value x /*in out*/, shared__T_value y /*in*/);

extern void server__op2(shared__T_value x /*in*/);

extern void server__op3(void);

/* ---------- obcs specification: ------------------------------------------- */

/*  OBCS init, exec and termination procedures:                               */
Process * server__OBCS_init(void);
void server__OBCS_proc(Process * server__OBCS);
void server__OBCS_stop(void);
void server__OBCS_term(void);

/*  Server Tasks init, exec and termination procedures:                       */
Process * server__op3_init(void);
void server__op3_proc(Process * server__op3_st);
void server__op3_stop(void);
void server__op3_term(void);

/* End Spec of server                                                         */
#endif
