/*-----------------------------
 * STOOD V5
 * Copyright TNI Europe 2004
 * Database checker
 *------------------------------
 * (cf.RASTO/03.035) 
 */

checkH :- isCurrentRoot(R), writeHierarchy(R,R).

writeHierarchy(M,R) :- objectLevel(M,L), writeLine(L,M,R), isObject(C,_,M), writeHierarchy(C,R).

writeLine(L,M,R) :- write(L), indent(L), write(M), indent(L,M,R), write(R), nl.

indent(L) :- I is 3 * L, $tab(I).

indent(L,M,R) :- $conlength(M,L1), I is 3 * L, L2 is I + L1, $conlength(R,L3), L4 is L2 + L3, L5 is 70 - L4, $tab(L5).
 
 