/*-----------------------------
 * STOOD V5
 * Copyright TNI Europe 2004
 * Database checker
 *------------------------------
 * (cf.RASTO/04.005) 
 */

checkS :- thisFile(F, 'check.pro'), concat('ls -l ',F,C), $system(C), nl, fail.
checkS :- cpt2Rst, isObject(X,_,_), scan(X), fail.
checkS :- write('*** Grand Total: '), cpt2Get(I), write(I), write(' files.'), nl.

scan(X) :- cpt3Rst, allFiles(X,F), write2(F), cpt3Inc, nl, fail.
scan(X) :- write('*** Total: '), cpt3Get(I), cpt2Add(I), write(I), write(' files for Module: '), write(X), nl.

allFiles(X,F) :- 
	/* file(_,_,X,F,_); redundant for target language */
	file(_,_,_,X,F,_);
	comment(_,_,X,F,_);
	description(X,F,_).

concat(A,B,C) :- $name(A,L1), $name(B,L2), 
	$append(L1,L2,L), $name(C,L).
