/*``changes``Thu May 17 15:35:34 MET DST 2001``*/
/* version */
/*-------------------------------------------------
	STOOD v5.0
	HOOD 4 rules checker 
	Visibility rules: HRM4 p96-97

	Copyright TNI Europe 2005
	Pierre DISSAUX (pierre.dissaux@tni.fr)
	17.Mar.1999
	29.Jul.1999: V18
	21.Jun.2000: V11
	13.Jul.2000: V9
------------------------------------------------*/
/**** changes ****/
/*------------------------------------------------
HOOD025 (21.Mar.2005) suppressing rule V1 (bad behavior in mode check system)
------------------------------------------------*/
/**** visibility rules ****/
/*-----------------------------------------------*/
 
/*``Reserved_words``Wed Mar 17 16:18:54 MET 1999``*/
/* HOOD4*/

isReserved('ATTRIBUTES','HOOD').
isReserved('ASER_BY_IT','HOOD').
isReserved('ASER','HOOD').
isReserved('ACTIVE','HOOD').
isReserved('ABSTRACT','HOOD').
isReserved('BY_VALUE','HOOD').
isReserved('BY_REFERENCE','HOOD').
isReserved('BY_POINTER','HOOD').
isReserved('BY_IT','HOOD').
isReserved('CONSTRAINED_OPERATIONS','HOOD').
isReserved('CONSTRAINED_BY','HOOD').
isReserved('CONSTANTS','HOOD').
isReserved('CODE','HOOD').
isReserved('CLASS','HOOD').
isReserved('DESCRIPTION','HOOD').
isReserved('DATAFLOWS','HOOD').
isReserved('DATA','HOOD').
isReserved('EXCEPTION_FLOWS','HOOD').
isReserved('EXCEPTIONS','HOOD').
isReserved('ENVIRONMENT','HOOD').
isReserved('END_OPERATION','HOOD').
isReserved('END_OBJECT','HOOD').
isReserved('END','HOOD').
isReserved('FORMAL_PARAMETERS','HOOD').
isReserved('GENERIC','HOOD').
isReserved('HSER_TOER','HOOD').
isReserved('HSER','HOOD').
isReserved('HANDLED_EXCEPTIONS','HOOD').
isReserved('IS','HOOD').
isReserved('INTERNALS','HOOD').
isReserved('INSTANCE_RANGE','HOOD').
isReserved('INSTANCE_OF','HOOD').
isReserved('INHERITED','HOOD').
isReserved('INHERITANCE','HOOD').
isReserved('IN','HOOD').
isReserved('IMPLEMENTED_BY','HOOD').
isReserved('IMPLEMENTATION_OR_SYNCHRONIZATION_CONSTRAINTS','HOOD').
isReserved('IMPLEMENTATION_OR_SYNCHRONISATION_CONSTRAINTS','HOOD').
isReserved('IMPLEMENTATION_CONSTRAINTS','HOOD').
isReserved('LSER_TOER','HOOD').
isReserved('LSER','HOOD').
isReserved('MTEX','HOOD').
isReserved('MEMBER_OF','HOOD').
isReserved('NONE','HOOD').
isReserved('OUT','HOOD').
isReserved('OSTD','HOOD').
isReserved('OP_CONTROL','HOOD').
isReserved('OPERATION_SETS','HOOD').
isReserved('OPERATION_CONTROL_STRUCTURES','HOOD').
isReserved('OPERATIONS','HOOD').
isReserved('OPERATION','HOOD').
isReserved('OBJECT_CONTROL_STRUCTURE','HOOD').
isReserved('OBJECTS','HOOD').
isReserved('OBJECT','HOOD').
isReserved('PSEUDO_CODE','HOOD').
isReserved('PROVIDED_INTERFACE','HOOD').
isReserved('PROTOCOL','HOOD').
isReserved('PROPAGATED_EXCEPTIONS','HOOD').
isReserved('PRAGMA','HOOD').
isReserved('PASSIVE','HOOD').
isReserved('PARAMETERS','HOOD').
isReserved('RWER','HOOD').
isReserved('ROER','HOOD').
isReserved('RLSER','HOOD').
isReserved('RETURN','HOOD').
isReserved('REQUIRED_INTERFACE','HOOD').
isReserved('RASER','HOOD').
isReserved('RAISED_BY','HOOD').
isReserved('STATE','HOOD').
isReserved('SIF_VERSION','HOOD').
isReserved('TYPES','HOOD').
isReserved('TOOL_VERSION','HOOD').
isReserved('TOOL_NAME','HOOD').
isReserved('TO','HOOD').
isReserved('TARGET_LANGUAGE','HOOD').
isReserved('USED_OPERATIONS','HOOD').
isReserved('VIRTUAL_NODE','HOOD').
 
/*``Reserved_words``Wed Mar 17 16:19:05 MET 1999``*/
/* Ada95 */

isReserved('abort','ada').
isReserved('abs','ada').
isReserved('abstract','ada').
isReserved('accept','ada').
isReserved('access','ada').
isReserved('aliased','ada').
isReserved('all','ada').
isReserved('and','ada').
isReserved('array','ada').
isReserved('at','ada').
isReserved('begin','ada').
isReserved('body','ada').
isReserved('case','ada').
isReserved('constant','ada').
isReserved('declare','ada').
isReserved('delay','ada').
isReserved('delta','ada').
isReserved('digits','ada').
isReserved('do','ada').
isReserved('else','ada').
isReserved('elsif','ada').
isReserved('end','ada').
isReserved('entry','ada').
isReserved('exception','ada').
isReserved('exit','ada').
isReserved('for','ada').
isReserved('function','ada').
isReserved('generic','ada').
isReserved('goto','ada').
isReserved('if','ada').
isReserved('in','ada').
isReserved('is','ada').
isReserved('limited','ada').
isReserved('loop','ada').
isReserved('mod','ada').
isReserved('new','ada').
isReserved('not','ada').
isReserved('null','ada').
isReserved('of','ada').
isReserved('or','ada').
isReserved('others','ada').
isReserved('out','ada').
isReserved('package','ada').
isReserved('pragma','ada').
isReserved('private','ada').
isReserved('procedure','ada').
isReserved('protected','ada').
isReserved('raise','ada').
isReserved('range','ada').
isReserved('record','ada').
isReserved('rem','ada').
isReserved('renames','ada').
isReserved('requeue','ada').
isReserved('return','ada').
isReserved('reverse','ada').
isReserved('select','ada').
isReserved('separate','ada').
isReserved('subtype','ada').
isReserved('tagged','ada').
isReserved('task','ada').
isReserved('terminate','ada').
isReserved('then','ada').
isReserved('type','ada').
isReserved('until','ada').
isReserved('use','ada').
isReserved('when','ada').
isReserved('while','ada').
isReserved('with','ada').
isReserved('xor','ada').
 
/*``Reserved_words``Wed Mar 17 16:19:18 MET 1999``*/
/* C++ */

isReserved('void','cpp').
isReserved('auto','cpp').
isReserved('static','cpp').
isReserved('extern','cpp').
isReserved('register','cpp').
isReserved('typedef','cpp').
isReserved('struct','cpp').
isReserved('union','cpp').
isReserved('enum','cpp').
isReserved('char','cpp').
isReserved('float','cpp').
isReserved('double','cpp').
isReserved('int','cpp').
isReserved('short','cpp').
isReserved('long','cpp').
isReserved('unsigned','cpp').
isReserved('if','cpp').
isReserved('else','cpp').
isReserved('while','cpp').
isReserved('do','cpp').
isReserved('for','cpp').
isReserved('switch','cpp').
isReserved('break','cpp').
isReserved('continue','cpp').
isReserved('return','cpp').
isReserved('goto','cpp').
isReserved('case','cpp').
isReserved('default','cpp').
isReserved('sizeof','cpp').
isReserved('asm','cpp').
isReserved('class','cpp').
isReserved('const','cpp').
isReserved('delete','cpp').
isReserved('friend','cpp').
isReserved('inline','cpp').
isReserved('new','cpp').
isReserved('operator','cpp').
isReserved('overload','cpp').
isReserved('public','cpp').
isReserved('private','cpp').
isReserved('protected','cpp').
isReserved('this','cpp').
isReserved('virtual','cpp').
 
/*``Reserved_words``Wed Mar 17 16:19:29 MET 1999``*/
/* C */

isReserved('void','c').
isReserved('auto','c').
isReserved('static','c').
isReserved('extern','c').
isReserved('register','c').
isReserved('typedef','c').
isReserved('struct','c').
isReserved('union','c').
isReserved('enum','c').
isReserved('char','c').
isReserved('float','c').
isReserved('double','c').
isReserved('int','c').
isReserved('short','c').
isReserved('long','c').
isReserved('unsigned','c').
isReserved('if','c').
isReserved('else','c').
isReserved('while','c').
isReserved('do','c').
isReserved('for','c').
isReserved('switch','c').
isReserved('break','c').
isReserved('continue','c').
isReserved('return','c').
isReserved('goto','c').
isReserved('case','c').
isReserved('default','c').
isReserved('sizeof','c').
 
/*``Visibility``Thu Feb 25 14:36:05 MET 1999``*/
/* HRM 4 rule V1: 
A ROOT name shall be unique within a SYSTEM_CONFIGURATION.*/

errV1(X,F) :- isRootObject(X,_,G), F \= G.

/*(cf.HOOD025)*/
/* checkV :- isRootObject(X,_,F), errV1(X,F), 
	write('ERROR : Root Module : '), write(X),
	write(' name is not unique within System_configuration ! (V1)'), nl. */
checkV :- printlf('---> rule V1 implicit...').
 
/*``Visibility``Thu Feb 25 14:37:44 MET 1999``*/
/* HRM 4 rule V2: 
A MODULE name shall be unique within a design tree.*/

/* implementation note:
this rule is checked at Module creation.*/

checkV :- printlf('---> rule V2 is implicit').
 
/*``Visibility``Thu Feb 25 14:38:55 MET 1999``*/
/* HRM 4 rule V3: 
A TYPE name shall be unique within a given MODULE.*/

/* implementation note:
this rule is checked at Type creation.*/

checkV :- printlf('---> rule V3 is implicit').
 
/*``Visibility``Thu Feb 25 14:39:52 MET 1999``*/
/* HRM 4 rule V4: 
A CONSTANT name shall be unique within a given MODULE.*/

/* implementation note:
this rule is checked at Constant creation.*/

checkV :- printlf('---> rule V4 is implicit').
 
/*``Visibility``Thu Feb 25 14:40:36 MET 1999``*/
/* HRM 4 rule V5: 
An EXCEPTION name shall be unique within a given MODULE.*/

/* implementation note:
this rule is checked at Exception creation.*/

checkV :- printlf('---> rule V5 is implicit').
 
/*``Visibility``Thu Feb 25 14:41:31 MET 1999``*/
/* HRM 4 rule V6: 
A DATA name shall be unique within a given MODULE.*/

/* implementation note:
this rule is checked at Data creation.*/

checkV :- printlf('---> rule V6 is implicit').
 
/*``Visibility``Thu Feb 25 14:44:15 MET 1999``*/
/* HRM 4 rule V7: 
An OPERATION may be overloaded within a MODULE.*/

/* implementation note:
overloading is allowed by STOOD.*/

checkV :- printlf('---> rule V7 is implicit').
 
/*``Visibility``Wed Mar 17 18:46:48 MET 1999``*/
/* HRM 4 rule V8: 
An ATTRIBUTE name shall be unique within a CLASS.*/

/* implementation note:
this rule is cannot be checked here.*/

checkV :- printlf('---> rule V8 not implemented.').
 
/*``Visibility``Thu Jul 13 14:19:44 MET DST 2000``*/
/* HRM 4 rule V9: 
A name shall not be a target language or HOOD reserved word.*/

/* implementation note:
HRM 4 Annex E HOOD reserved words list is not correct, 
SIF lexical elements are considered here .
last modified 13.07.2000 */

errV9(X,E,'ada') :- neoKetMemezTra(X,'STANDARD'), isReserved(F,'ada'), memezTra(E,F), !.
errV9(X,E,'c') :- X \= 'std', isReserved(F,'c'), memezTra(E,F), !.
errV9(X,E,'cpp') :- X \= 'std', isReserved(F,'cpp'), memezTra(E,F), !.

nameV9(X,E,K) :-
	( isObject(E,_,X), E\='FORMAL_PARAMETERS', K='MODULE' );
	isProvided(E,K,X);
	isInternal(E,K,X);
	( argument(_,_,X,_,E,_,_,_,_), K='PARAMETER' );
	( attributes(_,X,E,_,_,_), K='ATTRIBUTE' );
	( isState(X,E), K='STATE' );
	( isTransition(X,E,_,_,_), K='TRANSITION' ).

checkV :- isCurrentRoot(R), pragma_TARGET_LANGUAGE(R,L), 
	nameV9(X,E,K), errV9(X,E,L), 
	write('ERROR : '), write(K), write(' name : '), write(E), 
	write(' in Module : '), write(X), 
	write(' is a reserved word of : '), write(L), 
	write(' ! (V9_1)'), nl.
checkV :- nameV9(X,E,K), errV9(E,'HOOD'), 
	write('ERROR : '), write(K), write(' name : '), write(E), 
	write(' in Module : '), write(X), 
	write(' is a HOOD reserved word ! (V9_2)'), nl.
checkV :- printlf('---> rule V9 checked...').
 
/*``Visibility``Tue Mar  2 11:27:52 MET 1999``*/
/* HRM 4 rule V10: 
A MODULE has visibility on outside world only through its 
REQUIRED_INTERFACE.*/

/* implementation note:
in STOOD, Required_Interface is built from actual dependencies 
(procedure 36).*/

checkV :- printlf('---> rule V10 is implicit').
 
/*``Visibility``Wed Jun 21 17:58:09 MET DST 2000``*/
/* HRM 4 rule V11: 
An entity (OPERATION, TYPE, CONSTANT, EXCEPTION) 
not declared in the PROVIDED_INTERFACE of a MODULE 
cannot be referenced (i.e. is not visible) outside this MODULE.*/

/* last modified: 21 Jun 2000 */

errV11(E,K,Y) :- not(isProvided(E,K,Y)).

checkV :- requires(_,_,X,E,K,Y,_), X\=Y, Y \= '?', errV11(E,K,Y), 
	write('ERROR : '), write(K), write(' : '), write(E), 
	write(' should be declared in Provided_Interface of : '), write(Y), 
	write(' ! (V11)'), nl.
checkV :- printlf('---> rule V11 checked...').
 
/*``Visibility``Tue Mar  2 11:28:34 MET 1999``*/
/* HRM 4 rule V12: 
An entity declared in the REQUIRED_INTERFACE of a MODULE 
may be referenced (i.e. is visible) anywhere in this MODULE.*/

/* implementation note:
in STOOD, Required_Interface is built from actual dependencies 
(procedure 36).*/

checkV :- printlf('---> rule V12 is implicit').
 
/*``Visibility``Thu Feb 25 16:45:07 MET 1999``*/
/* HRM 4 rule V13: 
A CHILD has visibility on the REQUIRED_INTERFACE of its PARENT.*/

/* implementation note:
this is allowed by STOOD.*/

checkV :- printlf('---> rule V13 is implicit').
 
/*``Visibility``Tue Mar 16 10:22:38 MET 1999``*/
/* HRM 4 rule V14: 
A CHILD has no visibility on the PROVIDED_INTERFACE of its PARENT.*/

errv14(X,P,K,E) :- requires(_,_,X,E,K,P,_).

checkV :- hoodObject(X,_,P), errv14(X,P,K,E), 
	write('ERROR : child Module : '), write(X), 
	write(' should not reference '), write(K), write(' : '), write(E), 
	write(' of its parent ! (V14)'), nl.
checkV :- printlf('---> rule V14 checked...').
 
/*``Visibility``Thu Feb 25 17:13:23 MET 1999``*/
/* HRM 4 rule V15: 
A CHILD has visibility on the PROVIDED_INTERFACE of its SIBLINGS.*/

/* implementation note:
this is allowed by STOOD.*/

checkV :- printlf('---> rule V15 is implicit').
 
/*``Visibility``Thu Feb 25 17:10:57 MET 1999``*/
/* HRM 4 rule V16: 
PROVIDED_INTERFACE of a PARENT has visibility on the 
PROVIDED_INTERFACE of its CHILDren for implementation.*/

/* implementation note:
this is allowed by STOOD.*/

checkV :- printlf('---> rule V16 is implicit').
 
/*``Visibility``Thu Feb 25 17:10:49 MET 1999``*/
/* HRM 4 rule V17: 
A MODULE has visibility on ENVIRONMENTs and other ROOTs 
declared in the SYSTEM_CONFIGURATION.*/

/* implementation note:
this is allowed by STOOD.*/

checkV :- printlf('---> rule V17 is implicit').
 
/*``Visibility``Thu Jul 29 16:47:12 MET DST 1999``*/
/* STOOD rule V18: 
All entities (operation, type, constant, exception) declared
in the INTERNALS of an object cannot be accessed (i.e. are not
visible) from its PROVIDED_INTERFACE (except from Ada private types).*/

/* implementation note: 
this rule seems obvious, but no explicit HRM rule checks it. 
last modified: 29 Jul 1999*/

errV18(E,K,X) :- requires(U,_,X,E,K,X,W), 
	( W='TypeDef'; W='CstDef'; W='OpDecl'),
	not(file(U,'TYPE',X,_,'TypeDecl')).

checkV :- isInternal(E,K,X), errV18(E,K,X),
	write('ERROR : '), write(K), write(' : '), write(E),
	write(' of Module : '), write(X),
	write(' should not be required from its provided interface ! (V18)'), nl.
checkV :- printlf('---> additional rule V18 checked...').
 
