/*``utilities``Wed Sep  4 16:27:17 MET DST 1996``*/
/* getNAS(X,I) */

getNAS(X,I) :- cpt2Rst, uses(X,_,'OPERATION',1), cpt2Inc, fail.
getNAS(X,I) :- cpt2Get(I).
 
/*``utilities``Wed Sep  4 17:52:17 MET DST 1996``*/
/* getNASn(X,I,M) */

getNASn(X,I,M) :- cpt2Rst, uses(X,_,'OPERATION',1), cpt2Inc, fail.
getNASn(X,I,M) :- cpt2Get(J), getMaxNAS(X,M), N is J // M, I is N * 100.
 
/*``utilities``Wed Sep  4 16:30:26 MET DST 1996``*/
/* getNM(I) */

getNM(I) :- cpt3Rst, hoodObject(_,_,_), cpt3Inc, fail.
getNM(I) :- cpt3Get(I).
 
/*``utilities``Wed Sep  4 18:21:17 MET DST 1996``*/
/* getMaxNAS(X,I) */

getMaxNAS(X,I) :- cpt3Rst, (brothers(X,Y);uncle(X,Y);env(Y)), cpt3Inc, fail.
getMaxNAS(X,I) :- cpt3Get(I).

/*``utilities``Wed Oct  9 12:50:48 MET 1996``*/
/* getNOPR(X,I) */

getNOPR(X,I) :- cpt3Rst, requires(_,_,X,_,'OPERATION',Y,_), X\=Y, cpt3Inc, fail.
getNOPR(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Oct  9 12:51:14 MET 1996``*/
/* getNTYPR(X,I) */

getNTYPR(X,I) :- cpt3Rst, requires(_,_,X,_,'TYPE',Y,_), X\=Y, cpt3Inc, fail.
getNTYPR(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Oct  9 12:52:25 MET 1996``*/
/* getNCOPR(X,I) */

getNCOPR(X,I) :- cpt3Rst, requires(_,_,X,_,'CONSTANT',Y,_), X\=Y, cpt3Inc, fail.
getNCOPR(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Oct  9 12:52:39 MET 1996``*/
/* getNEXPR(X,I) */

getNEXPR(X,I) :- cpt3Rst, requires(_,_,X,_,'EXCEPTION',Y,_), X\=Y, cpt3Inc, fail.
getNEXPR(X,I) :- cpt3Get(I).
 
/*``utilities``Wed Sep  4 18:46:04 MET DST 1996``*/
/* getNER(X,I,) */

getNER(X,I) :- 
	cpt2Rst,
	getNOPR(X,A), cpt2Add(A),
	getNTYPR(X,B), cpt2Add(B), 
	getNCOPR(X,C), cpt2Add(C),
	getNEXPR(X,D), cpt2Add(D),
	cpt2Get(I).
 
/*``interface``Wed Sep  4 18:23:39 MET DST 1996``*/
/* number of output links : NAS */

coupling :- write('C O U P L I N G  :'), nl, nl,
	write('NUMBER OF USE LINKS FROM :'), nl, nl, cptRst,
	hoodObject(X,_,Y), Y\='SYSTEM_CONFIGURATION', tab, write('NAS-'), write(X), write(' = '),
	getNAS(X,I), write(I), cptAdd(I), nl, fail.
coupling :- tab, write('total NAS : '), cptGet(I), write(I), nl, nl, fail.
 
/*``interface``Wed Sep  4 18:23:27 MET DST 1996``*/
/* normalized output links : NASn */

coupling :- write('NORMALIZED NUMBER OF USE LINKS FROM :'), nl, nl, cptRst,
	hoodObject(X,_,Y), Y\='SYSTEM_CONFIGURATION', 
	tab, write('NASn-'), write(X), write(' = '), getNAS(X,I), write(I), getMaxNAS(X,M), write('/'), write(M), cptAdd(I), nl, fail.
 
/*``interface``Wed Sep  4 19:04:09 MET DST 1996``*/
/* required elements : NER */

coupling :- nl, write('NUMBER OF REQUIRED ELEMENTS :'), nl, nl, cptRst,
	hoodObject(X,_,Y), not(hoodObject(_,_,X)), Y\='SYSTEM_CONFIGURATION', cpt2Rst,
	getNOPR(X,A), cpt2Add(A),
	getNTYPR(X,B), cpt2Add(B), 
	getNCOPR(X,C), cpt2Add(C),
	getNEXPR(X,D), cpt2Add(D),
	tab, write('NER-'), write(X), write(' = '), cpt2Get(I), write(I), cptAdd(I), nl,
	tab, tab, write('NOPR : '), write(A), tab, write('NTYPR : '), write(B), tab, write('NCOPR : '), write(C), tab, write('NEXPR : '), write(D), nl, fail.
coupling :- tab, write('total NER : '), cptGet(I), write(I), nl, nl, fail.
 
