/*``operations``Tue Mar 19 16:15:59 MET 1996``*/
/* getNOPF(X,I) */

getNOPF(X,I) :- cptRst, isProvided(_,'OPERATION',X), cptInc, fail.
getNOPF(X,I) :- cptGet(I).

/*``operations``Tue Mar 19 16:15:57 MET 1996``*/
/* getNOPI(X,I) */

getNOPI(X,I) :- cptRst, isInternal(_,'OPERATION',X), cptInc, fail.
getNOPI(X,I) :- cptGet(I).

/*``operations``Tue Mar 19 18:08:18 MET 1996``*/
/* getNPOPF(X,I) */

getNPOPF(X,I) :- cptRst, isProvided(U,'OPERATION',X),
	(argument(U,'OPERATION',X,_,_,_,_,_); return(U,'OPERATION',X,_,_)),
	cptInc, fail.
getNPOPF(X,I) :- cptGet(I).
/*``operations``Tue Mar 19 18:08:33 MET 1996``*/
/* getNPOPI(X,I) */

getNPOPI(X,I) :- cptRst, isInternal(U,'OPERATION',X),
	(argument(U,'OPERATION',X,_,_,_,_,_); return(U,'OPERATION',X,_,_)),
	cptInc, fail.
getNPOPI(X,I) :- cptGet(I).
/*``utilities``Tue Dec 18 14:11:27 MET 2001``*/
/* getTer(X) */

getTer(X) :- hoodObject(X,_,Y), not(hoodObject(_,_,X)), 
	not(isInstance(X,_,_)), 
	( Y='SYSTEM_CONFIGURATION' -> isCurrentRoot(X); true).
/*``utilities``Tue Jun 11 15:37:19 MET DST 1996``*/
/* getPar(X) */

getPar(X) :- hoodObject(X,_,_), not(not(hoodObject(_,_,X))).

/* getChild(X,Y) */

getChild(X,Y) :-hoodObject(Y,_,X).
getChild(X,Y) :-hoodObject(Z,_,X), getChild(Z,Y).
 
/*``utilities``Tue Mar 19 16:50:25 MET 1996``*/
/* getTGL(X) */

getTGL(X) :- fail.
/*``utilities``Tue Mar 19 16:50:30 MET 1996``*/
/* getG(X) */

getG(X) :- isRootObject(X,T,_), (T='CLASS'; T='GENERIC'), not(isCurrentRoot(X)).
/*``utilities``Tue Mar 19 16:50:35 MET 1996``*/
/* getOE(X) */

getOE(X) :- isRootObject(X,'DESIGN',_), not(isCurrentRoot(X)).
/*``interface``Mon Sep  2 17:44:40 MET DST 1996``*/
/* number of modules : NO */

size :- write('S I Z E   O F   D E S I G N  :'), nl, nl,
	write('NUMBER OF MODULES :'), nl, nl,
	tab, write('Number of parent modules : 			NOPA = '), getNOPA(A), write(A), nl,
	tab, write('Number of terminal modules : 			NOT = '), getNOT(B), write(B), nl,
	tab, write('Number of terminal modules inside generics : unavailable'), nl,
	tab, write('Number of environment modules : 		NOE = '), getNOE(D), write(D), nl,
	tab, write('Number of generic modules : 			NG = '), getNG(E), write(E), nl,
	tab, write('Number of instances of generics : 		NI = '), getNI(F), write(F), nl,
	tab, write('Number of instances of generics inside generics : unavailable'), nl, nl,
	tab, write('Number of active terminal modules : 		NOA = '), getNOA(H), write(H), nl,
	tab, write('Number of passive terminal modules : 	NOP = '), getNOP(I), write(I), nl, nl,
	tab, write('Total number of modules in design : 		NTOC = '), getNTOC(J), write(J), nl,
	tab, write('Total number of modules : 				NTO = '), getNTO(K), write(K), nl, nl, fail.
/*``interface``Tue Mar 19 17:42:22 MET 1996``*/
/* number of provided operations : NOPF */

size :- cpt3Rst, write('NUMBER OF PROVIDED OPERATIONS :'), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules :'), nl, getTer(X),
	tab, tab, write('NOPF-Ter-'), write(X), write(' = '), getNOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPF-Ter* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules inside generics :'), nl, getTGL(X),
	tab, tab, write('NOPF-TGL-'), write(X), write(' = '), getNOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPF-TGL* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Generic modules :'), nl, getG(X),
	tab, tab, write('NOPF-G-'), write(X), write(' = '), getNOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPF-G* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Environment modules :'), nl, getOE(X),
	tab, tab, write('NOPF-OE-'), write(X), write(' = '), getNOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPF-OE* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- write('Total : NOPF** = '), cpt3Get(I), write(I), nl, nl, fail.

/*``interface``Tue Mar 19 17:43:01 MET 1996``*/
/* number of internal operations : NOPI */

size :- cpt3Rst, write('NUMBER OF INTERNAL OPERATIONS :'), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules :'), nl, getTer(X),
	tab, tab, write('NOPI-Ter-'), write(X), write(' = '), getNOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPI-Ter* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules inside generics :'), nl, getTGL(X),
	tab, tab, write('NOPI-TGL-'), write(X), write(' = '), getNOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPI-TGL* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Generic modules :'), nl, getG(X),
	tab, tab, write('NOPI-G-'), write(X), write(' = '), getNOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPI-G* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Environment modules :'), nl, getOE(X),
	tab, tab, write('NOPI-OE-'), write(X), write(' = '), getNOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NOPI-OE* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- write('Total : NOPI** = '), cpt3Get(I), write(I), nl, nl, fail.

/*``interface``Tue Mar 19 17:43:39 MET 1996``*/
/* number of provided parameters : NPOPF */

size :- cpt3Rst, write('NUMBER OF PARAMETERS IN PROVIDED OPERATIONS :'), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules :'), nl, getTer(X),
	tab, tab, write('NPOPF-Ter-'), write(X), write(' = '), getNPOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPF-Ter* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules inside generics :'), nl, getTGL(X),
	tab, tab, write('NPOPF-TGL-'), write(X), write(' = '), getNPOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPF-TGL* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Generic modules :'), nl, getG(X),
	tab, tab, write('NPOPF-G-'), write(X), write(' = '), getNPOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPF-G* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Environment modules :'), nl, getOE(X),
	tab, tab, write('NPOPF-OE-'), write(X), write(' = '), getNPOPF(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPF-OE* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- write('Total : NPOPF** = '), cpt3Get(I), write(I), nl, nl, fail.

/*``interface``Tue Jun 11 09:38:34 MET DST 1996``*/
/* number of internal parameters : NPOPI */

size :- cpt3Rst, write('NUMBER OF PARAMETERS IN INTERNAL OPERATIONS :'), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules :'), nl, getTer(X),
	tab, tab, write('NPOPI-Ter-'), write(X), write(' = '), getNPOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPI-Ter* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Terminal modules inside generics :'), nl, getTGL(X),
	tab, tab, write('NPOPI-TGL-'), write(X), write(' = '), getNPOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPI-TGL* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Generic modules :'), nl, getG(X),
	tab, tab, write('NPOPI-G-'), write(X), write(' = '), getNPOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPI-G* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- cpt2Rst, tab, write('Environment modules :'), nl, getOE(X),
	tab, tab, write('NPOPI-OE-'), write(X), write(' = '), getNPOPI(X,I), write(I), cpt2Add(I), nl, fail.
size :- tab, write('Sub-Total : NPOPI-OE* = '), cpt2Get(I), write(I), cpt3Add(I), nl, nl, fail.

size :- write('Total : NPOPI** = '), cpt3Get(I), write(I), nl, nl, fail.

/*``modules``Mon Mar 18 15:30:42 MET 1996``*/
/* getNOPA(I) */

getNOPA(I) :- cptRst, hoodObject(X,_,_), isNotTerm(X), cptInc, fail.
getNOPA(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 16:40:25 MET 1996``*/
/* getNOT(I) */

getNOT(I) :- cptRst, getTer(X), cptInc, fail.
getNOT(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 16:49:02 MET 1996``*/
/* getNOTG(I) */

getNOTG(I) :- cptRst, getTGL(X), cptInc, fail.
getNOTG(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 16:48:48 MET 1996``*/
/* getNOE(I) */

getNOE(I) :- cptRst, getOE(X), cptInc, fail.
getNOE(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 16:49:26 MET 1996``*/
/* getNG(I) */

getNG(I) :- cptRst, getG(X), cptInc, fail.
getNG(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 18:02:22 MET 1996``*/
/* getNI(I) */

getNI(I) :- cptRst, isInstance(X,_,_), cptInc, fail.
getNI(I) :- cptGet(I).
 
/*``modules``Mon Mar 18 15:32:30 MET 1996``*/
/* getNIG(I) */

getNIG(I) :- cptRst, fail.
getNIG(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 17:57:48 MET 1996``*/
/* getNOA(I) */

getNOA(I) :- cptRst, getTer(X), hoodObject(X,'ACTIVE',_), cptInc, fail.
getNOA(I) :- cptGet(I).
 
/*``modules``Tue Mar 19 17:56:41 MET 1996``*/
/* getNOP(I) */

getNOP(I) :- cptRst, getTer(X), hoodObject(X,'PASSIVE',_), cptInc, fail.
getNOP(I) :- cptGet(I).
/*``modules``Mon Mar 18 17:04:17 MET 1996``*/
/* getNTOC(I) */

getNTOC(I) :- cpt2Rst, 
	getNOPA(A), cpt2Add(A),
	getNOT(B), cpt2Add(B),
	getNOTG(C), cpt2Add(C),
	getNG(D), cpt2Add(D),
	getNI(E), cpt2Add(E),
	getNIG(F), cpt2Add(F),
	cpt2Get(I).
 
/*``modules``Mon Mar 18 17:26:00 MET 1996``*/
/* getNTO(I) */

getNTO(I) :- cpt3Rst, 
	getNTOC(A), cpt3Add(A),
	getNOE(B), cpt3Add(B),
	cpt3Get(I).
 


