/*``Always first loaded``Thu Feb  1 16:20:42 MET 2001``*/
/* stood v4.1 */
/*  main program : */

go :- 
	$init_sys,
	$getenv('PREDICATS',File),
	$consult(File),
	check, fail.

check :- check(N,R,S), memezTra(N,'ERMatrix'), 
	$loadqual(R,0), $tell(S); erm, fail; $told.
check :- check(N,R,S), memezTra(N,'REMatrix'), 
	$loadqual(R,0), $tell(S); rem, fail; $told.
check :- check(N,R,S), memezTra(N,'Coverage'), 
	$loadqual(R,0), $tell(S); coverage, fail; $told.
check :- check(N,R,S), memezTra(N,'Output'), 
	$loadqual(R,0), $tell(S); output, fail; $told.
check :- check(N,R,S), memezTra(N,'TabMatrix'), 
	$loadqual(R,0), $tell(S); tmx, fail; $told.
check :- check(N,R,S), memezTra(N,'OpMatrix'), 
	$loadqual(R,0), $tell(S); ocm, fail; $told.
 
/*``macro``Mon Mar 18 17:03:43 MET 1996``*/
/* counter 1 */

cptRst :- $globalset(cpt(0)).
cptPut(I) :- $globalset(cpt(I)).
cptGet(I) :- cpt(I).
cptInc :- cpt(I), J is I + 1, $globalset(cpt(J)).
cptDec :- cpt(I), J is I - 1, $globalset(cpt(J)).
cptAdd(I) :- cpt(J), K is J + I, $globalset(cpt(K)).
cptSub(I) :- cpt(J), K is J - I, $globalset(cpt(K)).
cptMul(I) :-  cpt(J), K is J * I, $globalset(cpt(K)).
cptDiv(I) :- cpt(J), K is J // I, $globalset(cpt(K)).
cptNeg :- cpt(I), J is -I, $globalset(cpt(J)).

/*``macro``Mon Mar 18 17:25:35 MET 1996``*/
/* counter 2 */

cpt2Rst :- $globalset(cpt2(0)).
cpt2Put(I) :- $globalset(cpt2(I)).
cpt2Get(I) :- cpt2(I).
cpt2Inc :- cpt2(I), J is I + 1, $globalset(cpt2(J)).
cpt2Dec :- cpt2(I), J is I - 1, $globalset(cpt2(J)).
cpt2Add(I) :- cpt2(J), K is J + I, $globalset(cpt2(K)).
cpt2Sub(I) :- cpt2(J), K is J - I, $globalset(cpt2(K)).
cpt2Mul(I) :-  cpt2(J), K is J * I, $globalset(cpt2(K)).
cpt2Div(I) :- cpt2(J), K is J // I, $globalset(cpt2(K)).
cpt2Neg :- cpt2(I), J is -I, $globalset(cpt2(J)).

/*``macro``Mon Mar 18 17:25:03 MET 1996``*/
/* counter 3 */

cpt3Rst :- $globalset(cpt3(0)).
cpt3Put(I) :- $globalset(cpt3(I)).
cpt3Get(I) :- cpt3(I).
cpt3Inc :- cpt3(I), J is I + 1, $globalset(cpt3(J)).
cpt3Dec :- cpt3(I), J is I - 1, $globalset(cpt3(J)).
cpt3Add(I) :- cpt3(J), K is J + I, $globalset(cpt3(K)).
cpt3Sub(I) :- cpt3(J), K is J - I, $globalset(cpt3(K)).
cpt3Mul(I) :-  cpt3(J), K is J * I, $globalset(cpt3(K)).
cpt3Div(I) :- cpt3(J), K is J // I, $globalset(cpt3(K)).
cpt3Neg :- cpt3(I), J is -I, $globalset(cpt3(J)).

/*``macro``Fri Feb  2 12:36:30 MET 2001``*/
/* user interface */

write(T) :- $writename(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
dot :- $put(46).
quote :- $put(34).
crlf :- $put(13), $put(10).
indent :- $put(32), $put(32), $put(32), $put(32).
 
/*``macro``Fri Apr 20 09:04:16 MET DST 2001``*/
/* hood interface */
/* (cf. RASTO/00.004) 07 December 2000 */

hoodObject(X,T,Z) :- isObject(X,T,Z), 
	X \= 'SYSTEM_DIAGRAM', X \= 'SYSTEM_CONFIGURATION', 
	X \= 'FORMAL_PARAMETERS'.

brothers(X,Y) :- hoodObject(X,_,Z), hoodObject(Y,_,Z), X \= Y.

uncle(X,Y) :- hoodObject(X,_,Z), brothers(Z,Y), not(env(Y)), not(hoodObject(Y,_,'SYSTEM_CONFIGURATION')).

env(X) :- isRootObject(X,'DESIGN',_), not(isCurrentRoot(X)).

isNotTerm(Y) :-  hoodObject(_,_,Y), !.

isTerm(Y) :- hoodObject(Y,_,_), not(hoodObject(_,_,Y)).

hasParameter(U,X) :- return(U,'OPERATION',X,_,_,_), !.
hasParameter(U,X) :- argument(U,'OPERATION',X,_,_,_,_,_,_), !.

convert('OPERATION','op','Operation',W) :- ( W='OpTxt'; W='Op2Txt'; W='OpBodyTxt'; W='ada::OpDef'; W='c::OpDef'; W='cpp::OpDef'; W='ada::OpDefExt'; W='ada::SepHeader'; W='OpModif' ), !.
convert('TYPE','ty','Type',W) :- ( W='TypeTxt'; W='Type2Txt'; W='ada::TypeDecl'; W='ada::TypeDef'; W='ada::TypeDef2'; W='c::TypeDef'; W='c::TypeDef2'; W='cpp::TypeDef'; W='cpp::TypeDef2' ), !.
convert('CONSTANT','co','Constant',W) :- ( W='CstTxt'; W='Cst2Txt'; W='ada::CstDecl'; W='ada::CstDef'; W='ada::CstDef2'; W='c::CstDef'; W='c::CstDef2'; W='cpp::CstDef'; W='cpp::CstDef2' ), !.
convert('EXCEPTION','ex','Exception',W) :- ( W='ExcTxt'; W='Exc2Txt' ), !.
convert('DATA','da','Data element',W) :- ( W='DataTxt'; W='ada::DataDef'; W='c::DataDef'; W='cpp::DataDef' ), !.
convert('STATE','st','State',W) :- ( W='StateTxt'; W='ada::SetState'; W='ada::GetState'; W='c::SetState'; W='c::GetState'; W='cpp::SetState'; W='cpp::GetState' ), !.
convert('TRANSITION','tr','Transition',W) :- ( W='TransTxt'; W='ada::Condition'; W='ada::Exception'; W='c::Condition'; W='c::Exception'; W='cpp::Condition'; W='cpp::Exception' ), !.
convert('NIL','ob','Problem',W) :- ( W='DOC11'; W='DOC12'; W='DOC131'; W='DOC132'; W='DOC133'; W='DOC141' ), !.
convert('NIL','ob','Solution',W) :- ( W='DOC21'; W='DOC221'; W='DOC231'; W='DOC232'; W='DOC241'; W='DOC26' ), !.
convert('NIL','ob','Implementation Constraints', 'O2').
convert('NIL','ob','Modifications','ObModif' ).
convert('NIL','ob','OBCS',W) :- ( W='ObcsTxt'; W='ObcsBodyTxt'; W='ada::obcs'; W='c::obcs'; W='cpp::obcs' ), !.
convert('NIL','ob','Code headers',W) :- ( W='ada::SpecHeader'; W='c::SpecHeader'; W='cpp::SpecHeader'; W='ada::BodyHeader'; W='c::BodyHeader'; W='cpp::BodyHeader'; W='ada::SepObcsHeader'; W='ada::SepHeader'; W='HeaderTxt' ), !. 

writeSection('OpTxt') :- write('operation spec. description (text)'), !.
writeSection('Op2Txt') :- write('operation spec. description (text)'), !.
writeSection('OpBodyTxt') :- write('operation body description (text)'), !.
writeSection('TypeTxt') :- write('type description (text)'), !.
writeSection('Type2Txt') :- write('type description (text)'), !.
writeSection('CstTxt') :- write('constant description (text)'), !.
writeSection('Cst2Txt') :- write('constant description (text)'), !.
writeSection('ExcTxt') :- write('exception description (text)'), !.
writeSection('Exc2Txt') :- write('exception description (text)'), !.
writeSection('DataTxt') :- write('data description (text)'), !.
writeSection('StateTxt') :- write('state description (text)'), !.
writeSection('TransTxt') :- write('trans description (text)'), !.
writeSection('ObcsTxt') :- write('obcs spec. description (text)'), !.
writeSection('ObcsBodyTxt') :- write('obcs body description (text)'), !.
writeSection('ada::OpDef') :- write('operation code (ada)'), !.
writeSection('ada::OpDefExt') :- write('operation code extension (ada)'), !.
writeSection('c::OpDef') :- write('operation code (c)'), !.
writeSection('cpp::OpDef') :- write('operation code (cpp)'), !.
writeSection('ada::TypeDecl') :- write('type pre-declaration (ada)'), !.
writeSection('ada::TypeDef') :- write('type definition (ada)'), !.
writeSection('ada::TypeDef2') :- write('type definition (ada)'), !.
writeSection('c::TypeDef') :- write('type definition (c)'), !.
writeSection('c::TypeDef2') :- write('type definition (c)'), !.
writeSection('cpp::TypeDef') :- write('type definition (cpp)'), !.
writeSection('cpp::TypeDef2') :- write('type definition (cpp)'), !.
writeSection('ada::CstDecl') :- write('constant pre-declaration (ada)'), !.
writeSection('ada::CstDef') :- write('constant definition (ada)'), !.
writeSection('ada::CstDef2') :- write('constant definition (ada)'), !.
writeSection('c::CstDef') :- write('constant definition (c)'), !.
writeSection('c::CstDef2') :- write('constant definition (c)'), !.
writeSection('cpp::CstDef') :- write('constant definition (cpp)'), !.
writeSection('cpp::CstDef2') :- write('constant definition (cpp)'), !.
writeSection('ada::DataDef') :- write('data declaration (ada)'), !.
writeSection('c::DataDef') :- write('data declaration (c)'), !.
writeSection('cpp::DataDef') :- write('data declaration (cpp)'), !.
writeSection('ada::SetState') :- write('state assignment (ada)'), !.
writeSection('ada::GetState') :- write('state test (ada)'), !.
writeSection('c::SetState') :- write('state assignment (c)'), !.
writeSection('c::GetState') :- write('state test (c)'), !.
writeSection('cpp::SetState') :- write('state assignment (cpp)'), !.
writeSection('cpp::GetState') :- write('state test (cpp)'), !.
writeSection('ada::Condition') :- write('trans condition (ada)'), !.
writeSection('ada::Exception') :- write('trans exception (ada)'), !.
writeSection('c::Condition') :- write('trans condition (c)'), !.
writeSection('c::Exception') :- write('trans exception (c)'), !.
writeSection('cpp::Condition') :- write('trans condition (cpp)'), !.
writeSection('cpp::Exception') :- write('trans exception (cpp)'), !.
writeSection('ada::obcs') :- write('obcs code (ada)'), !.
writeSection('c:obcs') :- write('obcs code (c)'), !.
writeSection('cpp::obcs') :- write('obcs code (cpp)'), !.
writeSection('DOC11') :- write('Statement of the Problem (text)'), !.
writeSection('DOC12') :- write('Referenced Documents (text)'), !.
writeSection('DOC131') :- write('Structural Requirements (text)'), !.
writeSection('DOC132') :- write('Functionnal Requirements (text)'), !.
writeSection('DOC133') :- write('Behavioural Requirements (text)'), !.
writeSection('DOC141') :- write('Parent General Description (text)'), !.
writeSection('DOC21') :- write('General Strategy (text)'), !.
writeSection('DOC221') :- write('Identification of Data Structures (text)'), !.
writeSection('DOC231') :- write('Identification of Operations (text)'), !.
writeSection('DOC232') :- write('Grouping Operations (text)'), !.
writeSection('DOC241') :- write('Identification of Local Behaviour (text)'), !.
writeSection('DOC26') :- write('Justification of Design Decisions (text)'), !.
writeSection('O2') :- write('IMPLEMENTATION_CONSTRAINTS (text)'), !.
writeSection(W) :- write(W).
 
/*``macro``Wed Feb 23 14:13:53 MET 2000``*/
/* miscalleneous */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).

$member1(X,[Y|Z]) :- X=Y -> true; $member1(X,Z).
$member2(X,L) :- nonvar(L), L = [Y|Z], (X = Y ; $member2(X,Z)).

return(U,'OPERATION',X,_,_) :- return(U,'OPERATION',X,_,_,_).
argument(U,'OPERATION',X,_,_,_,_,_) :- argument(U,'OPERATION',X,_,_,_,_,_,_).
