$init_sys :- 
	$load('$opcode'), 
	$load('$assert'),
	$load('$db'),
	$load('$dbcmpl'),
	$load('$bio'),
	$load('$bmeta'),
	$load('$blist'),
	$load('$call'),
	$load('$glob'),
        $load('$meta'),
        $load('$mac'),
        $load('$read'),
        $load('$read_curr_op'),
        $load('$getclauses'),
	$load('$consult'),
	$load('$inlines'),
	$load('$inst1'),
	$load('$io'),
	$assert_union(loaded_mods(_),$loaded_mods(_)), /* nec for compile */
	$globalset('_$nofile_msg'(1)).

$exists(File) :- syscall(33,[File,0],R), R=0.
syscall(N,Arg,R) :- '_$builtin'(83).
repeat.
repeat :- repeat.
$closetail([]).
$closetail([_|L]) :- $closetail(L).
term_expansion(_,_) :- fail.
functor(X,Y,Z) :- $functor(X,Y,Z).
$member1(X,[Y|Z]) :- X=Y -> true; $member1(X,Z).
$name(X,L) :- nonvar(X), !, $name0(X,L).
$name(X,L) :- '_$builtin'(98).
$name0(X,L) :- '_$builtin'(99).
$reverse([],[]).
$reverse([H|T],L) :- $reverse1(T,L,[H]).
$reverse1([],L,L).
$reverse1([H|T],L,L1) :- $reverse1(T,L,[H|L1]).

'_$undefined_pred'(Term) :- fail.
/* $writename(Term), $writename(' not found !'), $nl. */
'_$keyboard_int'(Call) :- break,'_$call'(Call).
'_$interrupt'(Call,Code) :-
	Code =:= 0 -> '_$undefined_pred'(Call);
	  (Code =:= 1 -> '_$keyboard_int'(Call);
	      (Code =:= 2 -> 
		$tell(user),$writename('Stack Overflow!!'),$nl,abort
		;
		$writename('Illegal interrupt code'),halt
	      )
	  ).

$load(File) :- $buff_code(File,0,31 /*gb*/,0) -> $loadqual(File,0);
		not(not($nnload(File))).
$loadqual(File,Rc) :- '_$builtin'(11).

$nnload(File) :-
	$conlength(File,Flen),
	$readl_simpath(Dir),
	$conlength(Dir,Dlen),
	Wlen is Flen+Dlen+1,
	$alloc_heap(Wlen,Wname),
	$substring(0,Dlen,Dir,0,Wname,Dlen),
	$substring(0,1,'/',Dlen,Wname,Floc),
	$substring(0,Flen,File,Floc,Wname,Wlen),
	$loadqual(Wname,0),!.
$readl_simpath(Dir) :- $getenv('SIMPATH',Simpath),
	$readl_getenvdir(Simpath,0,Dir).
$readl_getenvdir(Simpath,Loc,Dir) :-
	$subdelim(1,':',Dir1,Loc,Simpath,Nloc) ->
		(Dir = Dir1; $readl_getenvdir(Simpath,Nloc,Dir));
		$conlength(Simpath,Len), Llen is Len-Loc,
		$substring(1,Llen,Dir,Loc,Simpath,_).
$getenv(Var,Val) :-
	$alloc_heap(4,Argbuff),
	$alloc_heap(4,Retbuff),
	$conlength(Var,Len),Nlen is Len+1,
	$alloc_perm(Nlen,Nstr), $buff_code(Argbuff,0,26/*pba*/,Nstr),
	$substring(0,Len,Var,0,Nstr,_),
	$buff_code(Nstr,Len,30/*pb*/,0),
	$brocall(2,Argbuff,Retbuff),
	$buff_code(Retbuff,0,25/*bb*/,Val),
	$trimbuff(-1,Val,1,0).
$brocall(Callno,Argbuff,Retbuff) :- '_$builtin'(100).

$alloc_perm(Size, Buff) :- $alloc_buff(Size,Buff,0,0,0).
$alloc_heap(Size, Buff) :- $alloc_buff(Size,Buff,1,0,0).

/* Type 0: perm, 1: heap, 2: from Supbuff */
$alloc_buff(Size,Buff,Type,Supbuff,Retcode) :- 
	$alloc_buff1(Size,Buff,Type,Supbuff,Retcode),
	(Retcode =\= 0 -> 
		$writename('alloc failed'),$nl,fail;
		true).
$alloc_buff1(Size,Buff,Type,Supbuff,Retcode) :- '_$builtin'(76).
$trimbuff(Size,Buff,Type) :- '_$builtin'(79).
$trimbuff(Size,Buff,Type,Supbuff) :- '_$builtin'(79).
$buff_code(Buff,Offset,Disc,Term) :- '_$builtin'(77).

/* Type = 0: no ep, 1: dynamic, 2: ep to compiled code, 3: buffer */
$symtype(Term,Type) :- '_$builtin'(42).
$substring(Dir,NumBytes,Const,Locin,Buff,Locout) :- '_$builtin'(51).
$subnumber(Dir,NumBytes,NumCon,Locin,Buff,Locout) :- '_$builtin'(52).
$subdelim(Dir,Delim,Const,Locin,Buff,Locout) :- '_$builtin'(53).
$conlength(Const,Len) :- '_$builtin'(54).

$hashval(Arg, Size, Hashval) :- '_$builtin'(43).
$writename(X) :- '_$builtin'(130).
$nl :- '_$builtin'(26).
$print(T) :- $writename(T).

/* extensions v2.2 */
uses(X,Y,E) :- uses(X,Y,E,1).
isImplementedBy(U,E,X,V,Y) :- isImplementedBy(U,E,X,V,Y,1).
isRootObject(X,T) :- isRootObject(X,T,_).

/* compatibilite v4 */
isConstrained(U,E,X,C,P,_) :- isConstrained(U,E,X,C,P).
argument(U,E,X,M,P,Y,T,V) :- argument(U,E,X,M,P,Y,T,V,_).
return(U,E,X,Y,T) :- return(U,E,X,Y,T,_).
