#ifndef SOCK_H
#define SOCK_H
/*  included files */
#include <stdio.h>
#include <locale.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/file.h>
#include <sys/filio.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/resource.h>
#include <netdb.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <netinet/in.h>
#include <stropts.h>
#include <sys/conf.h>

/* misc. defines */
#define OK	0
#define ERROR	-1
#define RETRY	1
#define END_OF_CONNECTION 1

typedef struct {
	int serverPort, length; 
	int socketID;
	int otherID;
	char buffer[BUFSIZ];
	int EOR;
	int EOS;
	int first;
	} PCHANNEL_t;
#endif