/*``changes``Fri Jun 27 10:46:05 MET DST 1997``*/
/* reference : 13.sep.93 */
/**********************/ 
/* STOOD 5.0          */
/* Copyright TNI Europe 2004-2005 */
/* C++ code generator */
/******************************************************************************/
/*``changes``Tue Aug 23 16:26:07 MET DST 1994``*/
/* modif : 18.aug.94 : */
/* CPP001 : textual description of member functions now indented */
/* CPP002 : data and internal non member functions now static */
/* CPP003 : new pragma pure_virtual(op) */
/* CPP004 : new additional header file for specs : cpp::SpecHeader */
/* CPP005 : now recognizes DataBase spec file suffix */
/* CPP006 : new pragmas parapointer(ty) and parareference(ty) */
/* CPP007 : provided constants now fully declared inside spec */
/* CPP008 : types and constants now automatically reordered */
/* CPP009 : no more default values inside function bodies */
/* CPP010 : now manages operation overloading with a # character */
/* CPP011 : now allows arguments in main procedure */
/******************************************************************************/
/*``changes``Tue Apr  9 16:52:14 MET DST 1996``*/
/* modif : 13.oct.94 : */
/* CPP012 : now when pure virtual then no function definition (CPP003) */
/* CPP013 : now static keyword also inserted in function def (CPP002) */
/* CPP014 : now pragmas parapointer and pararef also for return (CPP006) */
/* CPP015 : const parameters now controled by "in" and pragma "return" */
/* CPP016 : bug fix in rule opName to manage operators */
/* CPP017 : allows protected member functions using pragma "protected" */
/******************************************************************************/
/*``changes``Fri Jun 27 10:47:28 MET DST 1997``*/
/* modif : 31.May.96 : */
/* CPP018 :  STOOD v4 update */
/* CPP019 :  translating HOOD4 generics into C++ templates */
/* CPP020 :  bug fixed in op renaming */
/* CPP021 :  '*' parameter allowed for pragma inline */
/* CPP022 :  new dependency rules */
/* CPP023 :  new message rules */
/* CPP024 : changes in makefile generation */
/******************************************************************************/
/*``changes``Fri Jun 27 10:47:25 MET DST 1997``*/
/* modif : 27.Jun.97 : */
/******************************************************************************/
/* last modif : 26.Apr.05 : */
/* CPP025 : default class generation */
/* CPP026 : remove non terms from makefile target */
/* CPP027 : fixing a bug in attributes dependencies */
/* CPP028 : changes in makefile + pragma ldflags */
/******************************************************************************/
/*``structure``Thu Aug 18 08:49:30 MET DST 1994``*/
/* MAIN */
/*-----*/

/*``structure``Thu Aug 18 08:49:53 MET DST 1994``*/
/* go */

go :- $init_sys, $getenv('PREDICATS',FileName), $consult(FileName), fail.
go :- initMakeFile, fail.
go :- genCpp, fail.
go :- endMakeFile, fail.

/*``structure``mardi, 15 octobre 1996, 12:42:59 MET``*/
/* gencpp */

genCpp :- 
	isObject(X,T,_),
	T \= 'OP_CONTROL',
	X \= 'SYSTEM_CONFIGURATION',
	X \= 'FORMAL_PARAMETERS',
	extract(X), ( 
		isInstance(X,_,C) -> instance(X,C);
		isTerm(X) -> termObject(X);
		isNesting(X) -> nestingObject(X);
		parentObject(X)	 ).
 
/*``structure``Thu Aug 18 08:28:44 MET DST 1994``*/
/* NOT TERMINAL OBJECTS */
/*******************************************/

/*``structure``mardi, 15 octobre 1996, 12:43:54 MET``*/
/* parentObject(X) - spec */
/*---------------*/
/* HEADER FILE : */
/*---------------*/

parentObject(X) :- openFile(X,'spec').
parentObject(X) :- insertCom(_,_,X,'HeaderTxt').
parentObject(X) :- insert(X,'BEGIN_SPEC'), insertH(X,'spec').
parentObject(X) :- insertFile(_,_,X,'SpecHeader').
parentObject(X) :- hasReq(X), ifCom, info(112), insertReqInt(X).
parentObject(X) :- hasReq(X,'spec'), info(102), needs('spec',X,Y), withes(X,Y).
parentObject(X) :- info(103), implementingObjects(X).
parentObject(X) :- hasProCo(X), info(10), isProvided(U,'CONSTANT',X), parentConst(X,U).
parentObject(X) :- hasProTy(X), info(11), isProvided(U,'TYPE',X), parentType(X,U).
parentObject(X) :- hasProOp(X), info(12), isProvided(U,'OPERATION',X), parentOp(X,U).
parentObject(X) :- hasObcs(X), info(28), insertOBCSSpec(X).
parentObject(X) :- hasProEx(X), info(30), isProvided(U,'EXCEPTION',X), insertEx(X,U).
parentObject(X) :- insert(X,'END_SPEC'), closeFile.
 
/*``structure``Fri Jun 27 09:31:33 MET DST 1997``*/
/* parentObject(X) - body */
/*---------------*/
/* SOURCE FILE : */
/*---------------*/

parentObject(X) :- main(X,U), parentBody(X,U).

parentBody(X,_) :- openFile(X,'body').
parentBody(X,_) :- insertCom(_,_,X,'HeaderTxt').
parentBody(X,_) :- info(101), withes(X,X).
parentBody(X,U) :- info(25), insertMain(X,U).
parentBody(X,_) :- closeFile.
 
/*``structure``Thu Aug 18 08:31:12 MET DST 1994``*/
/* TERMINAL OBJECTS */
/***********************************/

/*``structure``mardi, 15 octobre 1996, 12:44:33 MET``*/
/* termObject(X) - spec */
/*---------------*/
/* HEADER FILE : */
/*---------------*/

termObject(X) :- openFile(X,'spec').
termObject(X) :- insertCom(_,_,X,'HeaderTxt').
termObject(X) :- insert(X,'BEGIN_SPEC'), insertH(X,'spec').
termObject(X) :- insertFile(_,_,X,'SpecHeader').
termObject(X) :- hasReq(X), ifCom, info(112), insertReqInt(X).
termObject(X) :- hasReq(X,'spec'), info(102), needs('spec',X,Y), withes(X,Y).
termObject(X) :- termSpec(X).
termObject(X) :- insert(X,'END_SPEC'), closeFile.
 
/*``structure``mardi, 15 octobre 1996, 12:44:46 MET``*/
/* termObject(X) - body */
/*---------------*/
/* SOURCE FILE : */
/*---------------*/

termObject(X) :- openFile(X,'body').
termObject(X) :- insertCom(_,_,X,'HeaderTxt').
termObject(X) :- insert(X,'BEGIN_BODY'), insertFile(_,_,X,'Header').
termObject(X) :- info(101), withes(X,X).
termObject(X) :- hasReq(X,'body'), info(102), needs('body',X,Y), withes(X,Y).
termObject(X) :- termBody(X).
termObject(X) :- insert(X,'END_BODY'), closeFile.
 
 
/*``structure``mardi, 15 octobre 1996, 13:13:30 MET``*/
/* termSpec(X) */
/*-----------------*/
/* PROVIDED INTERFACE*/
/*-----------------*/

termSpec(X) :- hasProTyCo(X), info(31), provTyCo(X).
termSpec(X) :- hasProNm(X), info(15), isProvided(U,'OPERATION',X), notMember(X,U), insertProOpSpec(X,0,U).
termSpec(X) :- hasObcs(X), info(28), insertOBCSSpec(X).
termSpec(X) :- hasProEx(X), info(30), isProvided(U,'EXCEPTION',X), insertEx(X,U).
 
/*``structure``mardi, 15 octobre 1996, 13:13:48 MET``*/
/* termBody(X) */
/*-----------*/
/* INTERNALS */
/*-----------*/

termBody(X) :- hasIntTyCo(X), info(32), intTyCo(X).
termBody(X) :- hasIntNm(X), info(22), isInternal(U,'OPERATION',X), notMember(X,U), insertIntOpSpec(X,0,U).
termBody(X) :- hasIntDa(X), info(21), isInternal(U,'DATA',X), insertData(X,U).
termBody(X) :- hasObcs(X), info(29), insertOBCSBody(X).
termBody(X) :- hasProNi(X), info(23), isProvided(U,'OPERATION',X), notInline(X,U), notPure(X,U), insertOpBody(X,U).
termBody(X) :- hasIntOp(X), info(24), isInternal(U,'OPERATION',X), notPure(X,U), insertOpBody(X,U).
 
/*``structure``mardi, 15 octobre 1996, 17:36:45 MET``*/
/* instance(X,C) */

instance(X,C) :- openFile(X,'spec').
instance(X,C) :- insertCom(_,_,X,'HeaderTxt').
instance(X,C) :- insert(X,'BEGIN_SPEC'), insertH(X,'spec').
instance(X,C) :- insertFile(_,_,X,'SpecHeader').
instance(X,C) :- withes(X,C).
instance(X,C) :- needs('inst',X,Y), withes(X,Y).
instance(X,C) :- template(X).
instance(X,C) :- insert(X,'END_SPEC'), closeFile.
 
/*``structure``mardi, 15 octobre 1996, 17:36:42 MET``*/
/* template(X) */

template(X) :- isProvided(U,'TYPE',X), insertActualType(U,X).
 
/*``structure``Thu Aug 18 08:48:16 MET DST 1994``*/
/* NESTING OBJECTS */
/*********************************/

/*``structure``mardi, 15 octobre 1996, 12:46:03 MET``*/
/* nestingObject(X) - spec */
/*---------------*/
/* HEADER FILE : */
/*---------------*/

nestingObject(X) :- openFile(X,'spec').
nestingObject(X) :- insertCom(_,_,X,'HeaderTxt').
nestingObject(X) :- insert(X,'BEGIN_SPEC'), insertH(X,'spec').
nestingObject(X) :- insertFile(_,_,X,'SpecHeader').
nestingObject(X) :- hasReq(X), ifCom, info(112), insertReqInt(X).
nestingObject(X) :- hasReq(X,'nesting_spec'), info(102), needs('nesting_spec',X,Y), withes(X,Y).
nestingObject(X) :- insertNestedSpec(X).
nestingObject(X) :- insert(X,'END_SPEC'), closeFile.
 
/*``structure``mercredi, 16 octobre 1996, 09:28:31 MET``*/
/* nestingObject(X) - body */
/*---------------*/
/* SOURCE FILE : */
/*---------------*/

nestingObject(X) :- openFile(X,'body').
nestingObject(X) :- insertCom(_,_,X,'HeaderTxt').
nestingObject(X) :- insert(X,'BEGIN_BODY'), insertFile(_,_,X,'Header').
nestingObject(X) :- info(101), withes(X,X).
nestingObject(X) :- hasReq(X,'nesting_body'), info(102), needs('nesting_body',X,Y), withes(X,Y).
nestingObject(X) :- isNested(Y,X), not(isInstance(Y,_,_)), insert(Y,'NESTED'), termBody(Y).
nestingObject(X) :- insert(X,'END_BODY'), closeFile.
 
/*``visibility``Thu Aug 18 09:08:44 MET DST 1994``*/
/* VISIBILITY RULES */
/************************/

/*``visibility``mardi, 15 octobre 1996, 12:46:26 MET``*/
/* implementingObjects(X) */

implementingObjects(X) :- implements(Y,X), withes(X,Y).
 
/*``visibility``Fri May 31 09:51:59 MET DST 1996``*/
/* memezTra - id */

memezTra(A,B) :- $name(A,L1), $name(B,L2), id(L1,L2).

id([],[]) :- true.
id([E|L1],[F|L2]) :- ( E =:= F ; E =:= F-32 ; E-32 =:= F ), id(L1,L2).
 
/*``visibility``mardi, 15 octobre 1996, 12:46:42 MET``*/
/* insertNestedSpec(X) */

insertNestedSpec(X) :- isNested(Y,X), putNestedSpec(X,[Y]).

putNestedSpec(X,[Y|L]) :- hasReqNested(X,Y,Z) -> ( 
	(  $memberchk(Z,L) ->
		(  isClass(U,Z) -> 
			( insertPreDecl(Z,U), $assert(predecl(Z)) );
			( message('ERROR : cyclic dependency between : ',Y,' and : ',Z) ) );
		putNestedSpec(X,[Z,Y|L]) ),
	putNestedSpec(X,[Y|L]) ); nestedSpec(Y).

hasReqNested(X,Y,Z) :- isNested(Z,X), Y\=Z, not(nested(Z)),
	not(predecl(Z)), ( needs('spec',Y,Z); needs('inst',Y,Z) ).
 
/*``visibility``mardi, 15 octobre 1996, 17:40:28 MET``*/
/* nestedSpec(X) */

nestedSpec(X) :- not(nested(X)), insert(X,'NESTED'), $assert(nested(X)),
	( isInstance(X,_,C) -> template(X); termSpec(X) ), fail.
nestedSpec(X).

/* used(U,X,Y,W) */
/* CPP025, CPP027 */

used(U,X,Y,W) :- requires(U,_,X,_,_,Y,W).
used(U,X,Y,'TypeDef') :- ( inherits(U,X,_,Y); attributes(U,X,_,Y,_,_) ), Y\=''.
used(U,X,Y,'TypeDef2') :- ( inherits(U,X,_,Y); attributes(U,X,_,Y,_,_) ), Y\=''.
 
/*``visibility``mardi, 15 octobre 1996, 12:56:05 MET``*/
/* needs('spec',X,Y) */
/*-------------------------------------------*/
/* Visibility requirements for header file :   */
/*-------------------------------------------*/

needs('spec',X,Y) :- used(U,X,Y,W), X\=Y, /* CPP025 */
	( isProvided(U,_,X) /*; (isInternal(U,_,X), neededInSpec(U,_,X,[])) */),
	( W='TypeDef'; W='CstDef'; W='OpDecl'; (isInline(X,U), W='OpDef') ).
 
/*``visibility``mardi, 15 octobre 1996, 12:55:42 MET``*/
/* needs('nesting_spec',P,Y) */
/*-------------------------------------------*/
/* Visibility requirements for header of nesting file : */
/*-------------------------------------------*/

needs('nesting_spec',P,Y) :- 
	isNested(X,P), used(U,X,Y,W), not(isNested(Y,P)), /* CPP025 */
	( isProvided(U,_,X) /*; (isInternal(U,_,X), neededInSpec(U,_,X,[]))*/ ),
	( W='TypeDef'; W='CstDef'; W='OpDecl'; (isInline(X,U), W='OpDef') ).
 
/*``visibility``mardi, 15 octobre 1996, 12:58:54 MET``*/
/* needs('body',X,Y) */
/*-------------------------------------------*/
/* Visibility requirements for source file : */
/*-------------------------------------------*/
 
needs('body',X,Y) :- used(U,X,Y,W), X\=Y, ( /* CPP025 */
	( isInternal(U,_,X), ( W='TypeDef2'; W='CstDef2'; W='DataDef'; W='OpDecl2'; W='OpDef') );
	( isProvided(U,_,X), notInline(X,U), W='OpDef' ) ).
 
/*``visibility``mardi, 15 octobre 1996, 12:58:40 MET``*/
/* needs('nesting_body',P,Y) */
/*-------------------------------------------*/
/* Visibility requirements for source of nesting file : */
/*-------------------------------------------*/
 
needs('nesting_body',P,Y) :- isNested(X,P), used(U,X,Y,W), ( /* CPP025 */
	( isInternal(U,_,X), ( W='TypeDef2';  W='CstDef2'; W='DataDef'; W='OpDecl2'; W='OpDef') );
	( isProvided(U,_,X), notInline(X,U), W='OpDef' ) ).
 
/*``visibility``Fri May 31 15:26:17 MET DST 1996``*/
/* needs('inst',X,Y) */
/*-------------------------------------------*/
/* Visibility requirements for instance : CPP019 */
/*-------------------------------------------*/
 
needs('inst',X,Y) :- requires(_,_,X,_,_,Y,'InstPars'), X\=Y.
 
/*``visibility``mardi, 15 octobre 1996, 13:00:37 MET``*/
/* whichType - getType */
/*----------------------------------*/
/* types and constants dependencies */
/*----------------------------------*/

whichType(U,'CONSTANT',X,V,Y,O,T) :- isImplementedBy(V,'CONSTANT',Y,W,Z) ->
        whichType(U,'CONSTANT',X,W,Z,O,T) ;
        ( requires(V,'CONSTANT',Y,R,'TYPE',Y,W), ( W='CstDef'; W='CstDef2' ), getType(R,Y,O,T,X) ).

getType(R,Y,O,T,X) :- isImplementedBy(S,'TYPE',Z,R,Y) ->
        ( (Z=X) -> T=S; getType(S,Z,O,T,X) );
        ( T=R, O=Y ).
/*``visibility``Fri May 31 09:52:44 MET DST 1996``*/
/* insertReqInt - reqInt - reqs - insertReq */
/*--------------------*/
/* required interface */
/*--------------------*/

insertReqInt(X) :- reqInt(X,'OPERATION').
insertReqInt(X) :- reqInt(X,'EXCEPTION').
insertReqInt(X) :- reqInt(X,'TYPE').
insertReqInt(X) :- reqInt(X,'CONSTANT').
insertReqInt(X) :- reqInt(X,'DATA').

reqInt(X,E) :- begCom, tab, write('Required '), write(E), write(' :'),
        ( requires(_,_,X,_,E,Y,_), Y\=X ) -> endCom; ( write(' NONE'), endCom ).
reqInt(X,E) :- isProvided(U,E,Y), reqs(X,U,E,Y), insertReq(U,E,Y).

reqs(X,U,E,Y) :- requires(_,_,X,U,E,Y,_), not(memezTra(X,Y)), !.

insertReq(U,E,Y) :- begCom, tab, tab, write(E), write(' : '),
        write(U), write(' of module : '), write(Y), endCom.
 
/*``visibility``Fri Jun 27 10:45:39 MET DST 1997``*/
/* provTyCo(X) */
/*-------------------------------------------*/
/* provided types and constants dependencies CPP022 */
/*-------------------------------------------*/

provTyCo(X) :- isProvided(U,E,X), (E='TYPE'; E='CONSTANT'),
	putProvTyCo(X,[U]).

putProvTyCo(X,[U|L]) :- not(hasProvReq(X,U,_)), not(inSpec(X,U)),
	( isProvided(U,'TYPE',X) -> ( $assert(inSpec(X,U)), ( isClass(U,X) -> insertProClass(X,U); insertProType(X,U) ) );
	  isProvided(U,'CONSTANT',X) -> ( $assert(inSpec(X,U)), insertProConst(X,U) );
	  isInternal(U,_,X) ->
		( message('ERROR : internal type or const : ',U,' required in spec of : ',X), fail );
		( message('ERROR : unknown type or const : ',U,' required in spec of : ',X), fail ) ).
putProvTyCo(X,[U|L]) :- hasProvReq(X,U,V),
	( $memberchk(V,L) ->
		( message('ERROR : types and constants cyclic dependency in spec of : ',X), fail );
		putProvTyCo(X,[V,U|L]) ),
	putProvTyCo(X,[U|L]).

hasProvReq(X,U,V) :- requires(U,_,X,V,_,X,W), U\=V, 
	not(inSpec(X,V)), ( W='TypeDef'; W='CstDef' ). 
 
/*``visibility``mardi, 15 octobre 1996, 11:04:35 MET``*/
/* intTyCo(X) */
/*-------------------------------------------*/
/* internal types and constants dependencies CPP022 */
/*-------------------------------------------*/

intTyCo(X) :- isInternal(U,E,X), (E='TYPE'; E='CONSTANT'),
	putIntTyCo(X,[U]).

putIntTyCo(X,[U|L]) :- not(hasIntReq(X,U,_)), not(inInt(X,U)),
	( isInternal(U,'TYPE',X) -> ( $assert(inInt(X,U)), ( isClass(U,X) -> insertProClass(X,U); insertIntType(X,U) ) );
	  isInternal(U,'CONSTANT',X) -> ( $assert(inInt(X,U)), insertIntConst(X,U) );
	  ( message('ERROR : unknown type or const : ',U,' required in body of : ',X), fail ) ).
putIntTyCo(X,[U|L]) :- hasIntReq(X,U,V),
	( $memberchk(V,L) ->
		( message('ERROR : types and constants cyclic dependency in body of : ',X), fail );
		putIntTyCo(X,[V,U|L]) ),
	putIntTyCo(X,[U|L]).

hasIntReq(X,U,V) :- requires(U,_,X,V,E,X,W), U\=V, 
	not(inSpec(X,V)), not(inInt(X,V)), ( W='TypeDef2'; W='CstDef2' ).
 
/*``visibility``Fri May 31 09:53:07 MET DST 1996``*/
/* neededInSpec(U,E,X,L) */

neededInSpec(U,E,X,L) :- 
	requires(V,'TYPE',X,U,E,X,_), isProvided(V,'TYPE',X), !.
neededInSpec(U,E,X,L) :- 
	requires(V,'TYPE',X,U,E,X,_), isInternal(V,'TYPE',X), U\=V, 
	not($member(V,L)), neededInSpec(V,'TYPE',X,[U|L]), !.
neededInSpec(U,E,X,L) :- 
	requires(V,'CONSTANT',X,U,E,X,'CstDef'), U\=V, isInternal(V,'CONSTANT',X), 
	not($member(V,L)), neededInSpec(V,'CONSTANT',X,[U|L]), !.

notNeededInSpec(U,E,X) :- not( neededInSpec(U,E,X,[]) ).
 
/*``tuning``Thu Aug 18 09:19:28 MET DST 1994``*/
/* EXTRACTION TUNING */
/********************************/

/*``tuning``Wed Apr 16 11:20:26 MET DST 1997``*/
/* files : */
/*---------*/

ifCom :- pragma_comment(_), !.
lineWidth(W) :- pragma_line_width(L) -> W is L - 10; W is 70.
fullNames :- pragma_full_file_names(_), !.
remote(X,P) :- pragma_location(X,P).
ifPseudo :- pragma_insert_pseudo(_), !.
ifStd(X) :- pragma_std_file(X).
cFlags(F) :- pragma_compiler(_,_,F). /* CPP024 */
ldFlags(F) :- pragma_ldflags(_,F), !. /* CPP028 */
cC(C) :- pragma_compiler(_,C,_). /* CPP024 */
 
/*``tuning``mardi, 15 octobre 1996, 17:39:17 MET``*/
/* modules types */
/*---------------*/

isTerm(X) :- not(isObject(_,_,X)).
isParent(X) :- isObject(_,_,X), !.
isNesting(X) :- pragma_nesting(X), !.
isNested(X,Y) :- isObject(X,_,Y), pragma_nesting(Y).
isGeneric(X) :- isRootObject(X,'CLASS',_); isRootObject(X,'GENERIC',_).
opControl(X,U) :- isObject(Y,'OP_CONTROL',X), isProvided(U,'OPERATION',Y).
isRoot(X) :- isRootObject(Y,_), memezTra(X,Y), !.
 
/*``tuning``mardi, 15 octobre 1996, 13:53:23 MET``*/
/* modules characteristics : */
/*---------------------------*/

extract(X) :- extract(_,_,X,_,_), (isObject(X,_,Y) -> not(pragma_nesting(Y))), 
not(pragma_except(X)), !.
main(X,U) :- isCurrentRoot(X), pragma_main(_,U).
hasReq(X) :- ( requires(_,_,X,_,_,Y,_); inherits(_,X,_,Y); attributes(_,X,_,Y,_,_) ), Y\=X, !. /* CPP025 */
hasReq(X,W) :- needs(W,X,_), !.
hasProTyCo(X) :- (hasProCo(X); hasProTy(X)), !.
hasProCo(X) :- isProvided(_,'CONSTANT',X), !.
hasProTy(X) :- isProvided(_,'TYPE',X), !.
hasProNc(X) :- isProvided(U,'TYPE',X), notClass(U,X), !.
hasProCl(X) :- isProvided(U,'TYPE',X), isClass(U,X), !.
hasProOp(X) :- isProvided(_,'OPERATION',X), !.
hasProNm(X) :- isProvided(U,'OPERATION',X), notMember(X,U), !.
hasProIn(X) :- isProvided(U,'OPERATION',X), isInline(X,U), !.
hasProNi(X) :- isProvided(U,'OPERATION',X), notInline(X,U), notPure(X,U), !.
hasProEx(X) :- isProvided(_,'EXCEPTION',X), !.
hasIntTyCo(X) :- (hasIntCo(X); hasIntTy(X)), !.
hasIntCo(X) :- isInternal(_,'CONSTANT',X), !.
hasIntTy(X) :- isInternal(_,'TYPE',X), !.
hasIntNc(X) :- isInternal(U,'TYPE',X), notClass(U,X), !.
hasIntCl(X) :- isInternal(U,'TYPE',X), isClass(U,X), !.
hasIntDa(X) :- isInternal(_,'DATA',X), !.
hasIntNm(X) :- isInternal(U,'OPERATION',X), notMember(X,U), !.
hasIntOp(X) :- isInternal(_,'OPERATION',X), notPure(X,U), !.
hasObcs(X) :- isObject(X,'ACTIVE',_).
 
/*``tuning``Fri May 31 09:53:38 MET DST 1996``*/
/* child modules characteristics : */
/*---------------------------------*/

implements(Y,X) :- isObject(Y,_,X), imp(X,Y).
imp(X,Y) :- isImplementedBy(_,_,X,_,Y), !.
asc(X,Y) :- isObject(X,_,Y), !.
asc(X,Y) :- isObject(X,_,Z), asc(Z,Y).
 
/*``tuning``mercredi, 16 octobre 1996, 08:56:02 MET``*/
/* types characteristics : */
/*-------------------------*/

notClass(X,U) :- not(isClass(U,X)).
hasProMf(X,U) :- isProvided(V,'OPERATION',X), isMemberFunction(X,U,V), notProtected(X,V), !.
hasPtdMf(X,U) :- isProvided(V,'OPERATION',X), isMemberFunction(X,U,V), isProtected(X,V), !.
hasIntMf(X,U) :- isInternal(V,'OPERATION',X), isMemberFunction(X,U,V), notProtected(X,V), !.
hasItdMf(X,U) :- isInternal(V,'OPERATION',X), isMemberFunction(X,U,V), isProtected(X,V), !.
generic(X,U) :- requires(U,'TYPE',X,_,_,'FORMAL_PARAMETERS',_), !.
 
/*``tuning``mardi, 15 octobre 1996, 10:37:41 MET``*/
/* operations characteristics : */
/*------------------------------*/

isInline(X,U) :- (pragma_inline(X,U); pragma_inline(X,'*')), !.
notInline(X,U) :- not(pragma_inline(X,U)), not(pragma_inline(X,'*')).
isConst(X,U) :- pragma_return_const(X,U).
isVirtual(X,U) :- ( pragma_virtual(X,U); isPure(X,U) ), !.
isPure(X,U) :- isAbstract(U,'OPERATION',X).
notPure(X,U) :- not(isAbstract(U,'OPERATION',X)).
isExtern(X,U) :- pragma_extern(X,U).
isMemberFunction(X,C,U) :- argument(U,'OPERATION',X,M,P,_,C,_,_), 
	(memezTra(P,'me');memezTra(P,'myclass')).
notMember(X,U) :- not(isMemberFunction(X,_,U)).
classMember(X,U) :- argument(U,'OPERATION',X,M,P,_,C,_,_), memezTra(P,'myclass').
isProtected(X,U) :- pragma_protected(X,U), !.
notProtected(X,U) :- not(pragma_protected(X,U)).
 
/*``i/o``Tue Aug 16 13:37:41 MET DST 1994``*/
/* I/O RULES */
/*******************/

/*``i/o``Fri May 31 09:55:12 MET DST 1996``*/
/* basic i/o */

write(T) :- $writename(T).
print(T) :- $telling(F), $tell('user'), $writename(T), $tell(F).
nl :- $put(10).
tab :- $put(9).
sp :- $put(32).
indent(X,0) :- !.
indent(X,N) :- tab, M is N-1, indent(X,M).
 
/*``i/o``mardi, 15 octobre 1996, 12:40:13 MET``*/
/* insertFile(U,E,X,W) */

insertFile(U,E,X,W) :-  formalParameter(U,E,X) ->
        writeFile(U,E,'FORMAL_PARAMETERS',W);
        writeFile(U,E,X,W).
writeFile(U,E,X,W) :-
        file(U,E,X,F,W) -> ( $see(F), readFile(X), nl );
        (W ?= 'Header';W ?= 'SpecHeader') -> fail;
        (E ?= 'OPERATION') -> (write('{ }'), nl);
        ( message('ERROR : missing file for : ',U,' (',W,') of module : ',X), fail ).
 
/*``i/o``Tue May 28 14:32:11 MET DST 1996``*/
/* insertText(U,E,X,W) */

insertText(U,E,X,W) :- formalParameter(U,E,X) ->
        writeText(U,E,'FORMAL_PARAMETERS',W);
        writeText(U,E,X,W).
writeText(U,E,X,W) :-
        file(U,E,X,F,W) -> ( $see(F), readFile(X) );
        ( message('ERROR : missing file for : ',U,' (',W,') of module : ',X), fail ).
 
/*``i/o``Fri May 31 09:55:25 MET DST 1996``*/
/* insertCom(U,E,X,N,W) */

insertCom(U,E,X,W) :- insertCom(U,E,X,1,W).

insertCom(U,E,X,N,W) :- formalParameter(U,E,X) ->
        writeComm(U,E,'FORMAL_PARAMETERS',N,W);
        writeComm(U,E,X,N,W).
writeComm(U,E,X,N,W) :-
	comment(U,E,X,F,W) -> 
	( $see(F), indent(X,N), begCom, $globalset(w(N)), readComFile(X,N), endCom  );
	( W ?= 'ObcsTxt' ->
	  message('WARNING : no textual description for : OBCS spec of module : ',X);
        W ?= 'ObcsBodyTxt' ->
        message('WARNING : no textual description for : OBCS body of module : ',X);
	  W \= 'HeaderTxt' ->
	  message('WARNING :  no textual description for : ',E,' ',U,' of module : ',X) ), fail.
 
 
/*``i/o``Fri May 31 09:55:31 MET DST 1996``*/
/* insertDescr(X,H) */

insertDescr(X,H) :- description(X,F,H),
        $see(F), begCom, $globalset(w(1)), readComFile(X), endCom.
 
/*``i/o``Fri May 31 09:55:38 MET DST 1996``*/
/* insertPseudo(U,E,X,W) */

insertPseudo(U,E,X,W) :- formalParameter(U,E,X) ->
        writePseudo(U,E,'FORMAL_PARAMETERS',W);
        writePseudo(U,E,X,W).
writePseudo(U,E,X,W) :-
        file(U,E,X,F,W), findPseudo(F,G), $see(G),
        begCom, $globalset(w(1)), readComFile(X), endCom.

findPseudo(F1,F2) :-
        $name(F1,L1), $reverse(L1,[99|R]), $reverse([112|R],L2), $name(F2,L2).
 
/*``i/o``mardi, 15 octobre 1996, 15:14:41 MET``*/
/* openFile(X,S) */

openFile(X,S) :- extract(_,_,X,S,F),
	openMakeFile(G), writeFileName(X,F), write(' : '), closeMakeFile(G),
	( $tell(F) -> true; ( message('ERROR : cannot write : ',F, fail ) ) ).
 
/*``i/o``mardi, 15 octobre 1996, 15:16:36 MET``*/
/* closeFile */

closeFile :- $told,
	openMakeFile(G), nl, tab, write('touch $@'), nl, closeMakeFile(G).
 
/*``i/o``mardi, 15 octobre 1996, 15:17:14 MET``*/
/* open - close MakeFile */

openMakeFile(G) :- $telling(G),
	( extract(_,_,_,'make',F) ->  $tell(F,1); $tell('Stood.out') ).

closeMakeFile(G) :- $told, $tell(G).
 
/*``i/o``mardi, 15 octobre 1996, 15:17:31 MET``*/
/* init - end MakeFile */
/* CPP028 */

initMakeFile :- 
	openMakeFile(G), 
	write('SRC='), insertSources, 
	write('OBJ='), insertObj,
	write('CC='), insertCc, nl,
	write('CFLAGS= '), insertCFlags, nl,
	write('LDFLAGS='), insertLdFlags, nl,
	isCurrentRoot(X), write(X), write(' : $(SRC:.c=.o)'), nl,
	tab, ( main(X,_) -> 
		write('$(LINK.c) -o $@ $(LDFLAGS) $(SRC:.c=.o) $(OBJ)'); /*C045*/
		true ), nl,
	closeMakeFile(G).

endMakeFile.
 
/*``i/o``Fri May 31 09:56:28 MET DST 1996``*/
/* MakeFile components */

insertSources :- isObject(X,_,_), (isTerm(X); isNesting(X)), not(remote(X,_)), not(isNested(X,_)), /* CPP026 */
	extract(_,_,X,'body',F), writeFileName(X,F), sp, fail.
insertSources :- nl.

insertObj :- remote(X,P), writeObjFileName(X,P), sp, fail.
insertObj :- nl.

insertCFlags :- cFlags(F) -> write(F); write('-g').
insertLdFlags :- ldFlags(F) -> write(F); true. /*CPP028*/
insertCc :- cC(C) -> write(C); write('gcc'). /* CPP024 */
 
 
/*``i/o``Fri May 31 09:56:35 MET DST 1996``*/
/* readFile(X) */

readFile(X) :- 
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 			/* is it not end of file ? */
		(  $put(N),		/* if not eof then write char, and */
		   readFile(X)		/* read next char */
		);			/* or */
		$seen			/* if eof then close input file */
	).
 
/*``i/o``Fri May 31 09:56:46 MET DST 1996``*/
/* readComFile(X,I) */

readComFile(X,I) :-
	$get0(N),			/* read one char, and */
	(  N =\= -1 -> 			/* is it not end of file ? */
	   (  w(K), lineWidth(W),	/* if not eof then get counter value */
	      ( (K > W, N =:= 32) ->	/* is counter at max width and char space ? */
		newComLine(X,I) ;	/* if mw then create new line */
		( L is K+1, 		/* if not mw then increment counter */
		  $globalset(w(L))	/* and store its value */
		)			
	      ),			/* and */
	      ( N =:= 10 -> 		/* is it new line ? */
		newComLine(X,I) ;	/* if nl then write end of line, and */
		$put(N)			/* if not nl then write char, and */
	      ),			/* and */
	      readComFile(X,I)		/* read next char */
	   );				/* or */
	   $seen			/* if eof then close input file */
	).
 
/*``i/o``Fri May 31 09:56:52 MET DST 1996``*/
/* newComLine(X,I) */

newComLine(X,I) :- endCom, indent(X,I), begCom, $globalset(w(I)).
 
/*``i/o``mardi, 15 octobre 1996, 15:00:41 MET``*/
/* writeFileName(X,F) */

writeFileName(X,F1) :- ( remote(X,P) ->
	( write(P), write('/'), write(F1) );
	( fullNames -> 
		( write(F1) );
		( $name(F1,L1), $reverse(L1,R1), $name(N1,R1), 
		  $subdelim(1,'/',N2,0,N1,_), 
		  $name(N2,R2), $reverse(R2,L2), $name(F2,L2),
		  write(F2) ) ) ).
 
/*``i/o``Fri May 31 09:57:06 MET DST 1996``*/
/* writeEnvFileName(X) */

writeEnvFileName(X) :- (remote(X,P) -> ( write(P), write('/') ); true),
	write(X), write('.'), specFileSuffix(S), $put(S).
 
/*``i/o``Fri May 31 09:57:11 MET DST 1996``*/
/* specFileSuffix(S) */

specFileSuffix(S) :- extract(_,_,_,'spec',F), $name(F,L), $reverse(L,[S|R]), !.
 
/*``i/o``Fri May 31 09:57:16 MET DST 1996``*/
/* writeObjFileName(X,P) */

writeObjFileName(X,P) :- write(P), write('/'), write(X), write('.o').
 
/*``i/o``Fri May 31 09:34:47 MET DST 1996``*/
/* info */

info(10) :- begCom, write('---------- implemented_by constants : '), endCom.
info(11) :- begCom, write('---------- implemented_by types : '), endCom.
info(12) :- begCom, write('---------- implemented_by operations : '), endCom.
info(13) :- begCom, write('---------- provided types : '), endCom.
info(14) :- begCom, write('---------- provided classes : '), endCom.
info(15) :- begCom, write('---------- provided not member operations : '), endCom.
info(16) :- begCom, write('---------- provided inline operation bodies : '), endCom.
info(17) :- begCom, write('---------- provided constants : '), endCom.
info(18) :- begCom, write('---------- internal constants : '), endCom.
info(19) :- begCom, write('---------- internal types : '), endCom.
info(20) :- begCom, write('---------- internal classes : '), endCom.
info(21) :- begCom, write('---------- internal data : '), endCom.
info(22) :- begCom, write('---------- internal not member operations : '), endCom.
info(23) :- begCom, write('---------- provided operation bodies : '), endCom.
info(24) :- begCom, write('---------- internal operation bodies : '), endCom.
info(25) :- begCom, write('---------- main entry function : '), endCom.
info(26) :- begCom, write('---------- provided operations :'), endCom.
info(27) :- begCom, write('---------- internal operations :'), endCom.
info(28) :- begCom, write('---------- obcs specification :'), endCom.
info(29) :- begCom, write('---------- obcs body :'), endCom.
info(30) :- begCom, write('---------- provided exceptions :'), endCom.
info(31) :- begCom, write('---------- provided types and constants : '), endCom.
info(32) :- begCom, write('---------- internal types and constants : '), endCom.
info(101) :- begCom, write('========== visibility on specification file : '), endCom.
info(102) :- begCom, write('========== visibility on required modules : '), endCom.
info(103) :- begCom, write('========== visibility on child modules : '), endCom.
info(112) :- begCom, write('========== required interface : '), endCom.
 
/*``i/o``Fri May 31 09:57:32 MET DST 1996``*/
/* messages */

message(A) :- $telling(X), $tell('user'), write(A), nl, $tell(X).

message(A,B) :- 
	$telling(X), $tell('user'), 
	write(A), write(B), nl, 
	$tell(X).

message(A,B,C,D) :- 
	$telling(X), $tell('user'), 
	write(A), write(B), write(C), write(D), nl, 
	$tell(X).

message(A,B,C,D,E,F) :- 
	$telling(X), $tell('user'),
	write(A), write(B), write(C), write(D), write(E), write(F), nl,
	$tell(X).
 
/*``C++``Wed Apr 10 17:52:14 MET DST 1996``*/
/* C++ EXPRESSIONS */
/*****************************/

/*``C++``Fri May 31 09:57:54 MET DST 1996``*/
/* TEMPLATES */
/****************/
 
/*``C++``mercredi, 16 octobre 1996, 09:23:13 MET``*/
/* insertFormalParam(X,U) */

insertFormalParam(X,U) :- write('template <'), firstFParam(X,U,P), otherFParams(X,U,P).
insertFormalParam(X,U) :- write('>'), nl.

firstFParam(X,U,P) :- formalParameter(P,E,_) -> insertFParam(P,E); true.

otherFParams(X,U,P) :- formalParameter(Q,E,_), Q\=P, write(', '), insertFParam(Q,E).

insertFParam(U,'TYPE') :- write('class '), write(U).
insertFParam(U,'CONSTANT') :- constType('FORMAL_PARAMETERS',U,V), write(V), sp, write(U).
insertFParam(U,'OPERATION') :- return('FORMAL_PARAMETERS',_,U,_,V,_), write(V), sp, write(U).
 
/*``C++``mercredi, 16 octobre 1996, 09:24:24 MET``*/
 /* insertFormalParam2(X,U) */

insertFormalParam2(X,U) :- write('<'), firstFParam2(X,U,P), otherFParams2(X,U,P).
insertFormalParam2(X,U) :- write('>').

firstFParam2(X,U,P) :- formalParameter(P,_,_) -> write(P); true.

otherFParams2(X,U,P) :- formalParameter(Q,_,_), Q\=P, write(', '), write(Q).
 
/*``C++``mardi, 15 octobre 1996, 17:33:49 MET``*/
/* insertActualType(F,X) */

insertActualType(F,X) :- write('typedef '), write(F), write('<'), firstAParam(A), otherAParams(A).
insertActualType(F,X) :- write('> '), write(X), write('_'), write(F), nl.
 
firstAParam(U) :- actualParameter(U,_,_,V) -> write(V); true.

otherAParams(U) :- actualParameter(W,_,_,V), W\=U, write(', '), write(V).
 
/*``C++``Fri May 31 09:58:16 MET DST 1996``*/
/* C++ comments */

begCom :- write('// ').
endCom :- nl.
 
/*``C++``mardi, 15 octobre 1996, 13:03:21 MET``*/
/* packaging keywords */

insertH(X,H) :- 
	write('#ifndef INCLUDE_'), write(H), write('_'), write(X), nl,
	write('#define INCLUDE_'), write(H), write('_'), write(X), nl.

insert(X,'BEGIN_SPEC') :- begCom, write('SPEC OF MODULE : '), write(X), endCom.
insert(X,'END_SPEC') :- begCom, write('END OF MODULE : '), write(X), endCom, write('#endif'), nl.
insert(X,'BEGIN_BODY') :- begCom, write('BODY OF MODULE : '), write(X), endCom.
insert(X,'END_BODY') :- begCom, write('END OF MODULE : '), write(X), endCom.
insert(X,'NESTED') :- begCom, write('NESTED MODULE : '), write(X), endCom.
 
/*``C++``Fri May 31 09:58:41 MET DST 1996``*/
/* C++ CLASS DEFINITION */
/*----------------------*/
 
/*``C++``Wed May 29 17:57:00 MET DST 1996``*/
/* insertPreDecl(X,U) */

insertPreDecl(X,U) :- write('class '), write(U), write(';'), nl.
 
/*``C++``mardi, 15 octobre 1996, 13:11:50 MET``*/
/* insertProClass(X,U) */

insertProClass(X,U) :- ifCom, insertCom(U,'TYPE',X,'TypeTxt').
insertProClass(X,U) :- generic(X,U), insertFormalParam(X,U).
insertProClass(X,U) :- insertFile(U,'TYPE',X,'TypeDef') -> true; defaultClass(X,U). /* CPP025 */
insertProClass(X,U) :- hasProMf(X,U), write('public:'), nl.
insertProClass(X,U) :- isProvided(V,'OPERATION',X), isMemberFunction(X,U,V), notProtected(X,V), insertProOpSpec(X,1,V).
insertProClass(X,U) :- hasPtdMf(X,U), write('protected:'), nl.
insertProClass(X,U) :- isProvided(V,'OPERATION',X), isMemberFunction(X,U,V), isProtected(X,V), insertProOpSpec(X,1,V).
insertProClass(X,U) :- hasIntMf(X,U), write('private:'), nl.
insertProClass(X,U) :- isInternal(V,'OPERATION',X), isMemberFunction(X,U,V), insertIntOpSpec(X,1,V).
insertProClass(X,U) :- write('};'), nl, nl.
 
/*``C++``mardi, 15 octobre 1996, 13:12:03 MET``*/
/* insertIntClass(X,U) */

insertIntClass(X,U) :- ifCom, insertCom(U,'TYPE',X,'Type2Txt').
insertIntClass(X,U) :- generic(X,U), insertFormalParam(X,U).
insertIntClass(X,U) :- insertFile(U,'TYPE',X,'TypeDef2') -> true; defaultClass(X,U). /* CPP025 */
insertIntClass(X,U) :- hasIntMf(X,U), write('public:'), nl.
insertIntClass(X,U) :- isInternal(V,'OPERATION',X), isMemberFunction(X,U,V), notProtected(X,V), insertIntOpSpec(X,1,V).
insertIntClass(X,U) :- hasItdMf(X,U), write('protected:'), nl.
insertIntClass(X,U) :- isInternal(V,'OPERATION',X), isMemberFunction(X,U,V), isProtected(X,V), insertIntOpSpec(X,1,V).
insertIntClass(X,U) :- write('};'), nl, nl.

defaultClass(X,U) :- /* CPP025 */
	write('class '), write(U), 
	( inherits(U,X,V,_) -> ( write(' : public '), write(V) ); true ), nl, 
	write('{'), nl, 
	( attributes(U,X,_,_,_,_) -> ( write('private:'), nl ); true ),
	attributes(U,X,A,T,_,_), tab, write(T), sp, write(A), write(';'), nl.
 
/*``C++``Fri May 31 09:59:18 MET DST 1996``*/
/* C++ CONSTANTS */
/*--------------*/
 
/*``C++``Fri May 31 09:59:24 MET DST 1996``*/
/* parentConst(X,U) */

parentConst(X,U) :- isImplementedBy(U,'CONSTANT',X,V,Y), ( V=U ->
	( begCom, write('constant : '), write(U),
	  write(' is implemented by child module : '), write(Y), endCom );
	( write('#define '), write(U), sp, write(V), nl ) ).
 
/*``C++``Fri May 31 09:59:30 MET DST 1996``*/
/* insertConstSpec(X,U) */

insertConstSpec(X,U) :- ifCom, insertCom(U,'CONSTANT',X,'CstTxt').
insertConstSpec(X,U) :- constType(X,U,V), write('extern const '),
	write(V), sp, write(U), write(';'), nl.
 
/*``C++``Fri May 31 09:59:35 MET DST 1996``*/
/* constType(X,U,V) */

constType(X,U,V) :- requires(U,'CONSTANT',X,V,'TYPE',_,'CstDef') ->
	true; V='int'.
 
/*``C++``mardi, 15 octobre 1996, 11:07:11 MET``*/
/* insertProConst(X,U) */

insertProConst(X,U) :- ifCom, insertCom(U,'CONSTANT',X,'CstTxt').
insertProConst(X,U) :- write('const '), insertFile(U,'CONSTANT',X,'CstDef').
 
/*``C++``mardi, 15 octobre 1996, 11:07:06 MET``*/
/* insertIntConst(X,U) */

insertIntConst(X,U) :- ifCom, insertCom(U,'CONSTANT',X,'Cst2Txt').
insertIntConst(X,U) :- write('const '), insertFile(U,'CONSTANT',X,'CstDef2').
 
/*``C++``Fri May 31 09:59:46 MET DST 1996``*/
/* C++ TYPES */
/*---------*/
 
/*``C++``mardi, 15 octobre 1996, 15:59:28 MET``*/
/* parentType(X,U) */

parentType(X,U) :- isImplementedBy(U,'TYPE',X,V,Y), ( V=U ->
	( begCom, ( isClass(U,X) -> write('class : '); write('type : ') ), write(U),
	  write(' is implemented by child module : '), write(Y), endCom );
	( write('typedef '), write(V), sp, write(U), write(';'), nl ) ).
 
/*``C++``mardi, 15 octobre 1996, 10:51:22 MET``*/
/* insertProType(X,U) */

insertProType(X,U) :- ifCom, insertCom(U,'TYPE',X,'TypeTxt').
insertProType(X,U) :- insertFile(U,'TYPE',X,'TypeDef').
 
/*``C++``mardi, 15 octobre 1996, 10:45:56 MET``*/
/* insertIntType(X,U) */

insertIntType(X,U) :- ifCom, insertCom(U,'TYPE',X,'Type2Txt').
insertIntType(X,U) :- insertFile(U,'TYPE',X,'TypeDef2').
 
/*``C++``Fri May 31 10:00:04 MET DST 1996``*/
/* C++ DATA */
/*---------*/
 
/*``C++``Fri May 31 10:00:09 MET DST 1996``*/
/* insertData(X,U) */

insertData(X,U) :- ifCom, insertCom(U,'DATA',X,'DataTxt').
insertData(X,U) :- /*write('static '), */ insertFile(U,'DATA',X,'DataDef').
 
/*``C++``Fri May 31 10:00:14 MET DST 1996``*/
/* C++ FUNCTIONS :  */
/*----------------*/
 
/*``C++``Fri May 31 10:00:20 MET DST 1996``*/
/* parentOp(X,U) */

parentOp(X,U) :- isImplementedBy(U,'OPERATION',X,V,Y),
	( (opName(V,W),opName(U,W)) -> renameOp(X,U,Y); insertOpStub(X,U,Y,V) ).
 
/*``C++``mardi, 15 octobre 1996, 13:16:28 MET``*/
/* insertOpSpec(X,N,U) */

insertProOpSpec(X,N,U) :- ifCom, insertCom(U,'OPERATION',X,N,'OpTxt').
insertProOpSpec(X,N,U) :- insertOpSpec(X,N,U).

insertIntOpSpec(X,N,U) :- ifCom, insertCom(U,'OPERATION',X,N,'Op2Txt').
insertIntOpSpec(X,N,U) :- insertOpSpec(X,N,U).

insertOpSpec(X,N,U) :- indent(X,N), 
	((notMember(X,U),isInline(X,U)) -> write('inline '); true),
	((notMember(X,U),isInternal(U,'OPERATION',X)) -> write('static '); true),
	( classMember(X,U) -> write('static '); ( 
		(isExtern(X,U) -> write('extern '); true),
		(isVirtual(X,U) -> write('virtual '); true) ) ),
	opType(X,U), opProto(X,U).
 
/*``C++``Fri May 31 10:00:44 MET DST 1996``*/
/* renameOp(X,U,Y) */

renameOp(X,U,Y) :- begCom, write('operation : '), opType(X,U), opClass(X,U), opProto1(X,U).
renameOp(X,U,Y) :- begCom, write('is implemented by child module : '), write(Y), endCom.
 
/*``C++``mardi, 15 octobre 1996, 13:17:20 MET``*/
/* insertOpStub(X,U,Y,V) */

insertOpStub(X,U,Y,V) :- write('inline '), opType(X,U), opProto2(X,U).
insertOpStub(X,U,Y,V) :- write('{'), nl, tab, callType(Y,V), opCall(X,U,Y,V).
insertOpStub(X,U,Y,V) :- write('}'), nl.
 
/*``C++``mardi, 15 octobre 1996, 13:24:32 MET``*/
/* insertOpBody(X,U) */

insertOpBody(X,U) :- ifCom, insertCom(U,'OPERATION',X,'OpBodyTxt').
insertOpBody(X,U) :- ifPseudo, insertPseudo(U,'OPERATION',X,'OpDef').
insertOpBody(X,U) :- (isInline(X,U) -> write('inline '); true), 
	((notMember(X,U),isInternal(U,'OPERATION',X)) -> write('static '); true), 
	opType(X,U), opClass(X,U), opProto1(X,U).
insertOpBody(X,U) :- insertFile(U,'OPERATION',X,'OpDef'), nl.
 
/*``C++``Fri May 31 10:01:04 MET DST 1996``*/
/* insertMain(X,U) */

insertMain(X,U) :- opType(X,U), write('main ( int argc, char *argv[] )'), nl, 
	write('{'), nl,
	tab, opName(U,V), write(V), write('();'), nl,
	write('}'), nl.
 
/*``C++``Fri May 31 10:01:10 MET DST 1996``*/
/* PROTOTYPES : */
/*-------------*/
 
/*``C++``mardi, 15 octobre 1996, 13:26:16 MET``*/
/* opProto(X,U) */

opProto(X,U) :- opName(U,O), write(O), write('('),
	( (argument(U,'OPERATION',X,M,A,_,T,V,P), A\='me', A\='myclass') -> 
	insertArg(X,U,M,A,T,V,P) ).
opProto(X,U) :- write(')'), 
	( argument(U,'OPERATION',X,'in','me',_,_,_,_) -> write(' const'); true),
	( isInline(X,U) -> 
		( sp, insertFile(U,'OPERATION',X,'OpDef') );
		( ( isPure(X,U) -> write(' = 0'); true ) ),
		write(';'), nl ).
 
/*``C++``mardi, 15 octobre 1996, 13:26:27 MET``*/
/* opProto1(X,U) */

opProto1(X,U) :- opName(U,O), write(O), write('('),
        ( (argument(U,'OPERATION',X,M,A,_,T,V,P), A\='me', A \='myclass') ->
        insertArg(X,U,M,A,T,'',P) ).
opProto1(X,U) :- write(')'), 
	(argument(U,'OPERATION',X,'in','me',_,_,_,_) -> write(' const'); true), nl.
 
/*``C++``Fri May 31 10:01:48 MET DST 1996``*/
/* opProto2(X,U) */

opProto2(X,U) :- opName(U,O), write(O), write('('),
        ( (argument(U,'OPERATION',X,M,A,_,T,V,P) ) ->
        insertArg2(X,U,M,A,T,V,P) ).
opProto2(X,U) :- write(')'), nl.
 
/*``C++``mardi, 15 octobre 1996, 13:28:43 MET``*/
/* insertArg(X,U,A) */

insertArg(X,U,A) :- write(A).
insertArg(X,U,A) :- argument(U,'OPERATION',X,_,B,_,_,_,_), 
	A\=B, B\='me', B\='myclass', write(', '), write(B).
 
/*``C++``mardi, 15 octobre 1996, 13:28:56 MET``*/
/* insertArg(X,U,M,A,T,V,P) */

insertArg(X,U,M,A,T,V,P) :- writeType(X,T,M,P), writeArg(M,A,V).
insertArg(X,U,M,A,T,V,P) :- argument(U,'OPERATION',X,N,B,_,S,W,Q), A\=B, 
	B\='me', B\='myclass', write(', '), writeType(X,S,N,Q), writeArg(N,B,W).
 
/*``C++``Fri May 31 10:02:06 MET DST 1996``*/
/* insertArg2(X,U,M,A,T,V,P) */

insertArg2(X,U,M,A,T,V,P) :- writeType(X,T,M,P), writeArg(M,A,V).
insertArg2(X,U,M,A,T,V,P) :- argument(U,'OPERATION',X,N,B,_,S,W,Q), A\=B, 
        write(', '), writeType(X,S,N,Q), writeArg(N,B,W).
 
/*``C++``Fri May 31 10:02:13 MET DST 1996``*/
/* writeArg(M,A,V) */

writeArg(M,A,V) :-  write(A), (V\='' -> (write(' = '), write(V)); true).
 
/*``C++``mardi, 15 octobre 1996, 13:29:11 MET``*/
/* writeType(X,T,M,P) */

writeType(X,T,M,P) :- 
	((M?='in';M?='return_const') -> write('const '); true),
	write(T), sp, (P\='NIL' -> write(P); true).
 
/*``C++``mardi, 15 octobre 1996, 13:29:19 MET``*/
/* opCall(X,U,Y,V) */

opCall(X,U,Y,V) :- opName(V,O), write(O), write('('),
	( (argument(U,'OPERATION',X,_,A,_,_,_,_), A\='me', A\='myclass') ->
	  insertArg(X,U,A) ).
opCall(X,U,Y,V) :- write(');'), nl.
 
/*``C++``Fri May 31 10:02:30 MET DST 1996``*/
/* callType(X,U) */

callType(X,U) :- 
	( return(U,'OPERATION',X,_,_,_) -> write('return '); true ),
	( isMemberFunction(X,_,U) -> write('me.'); true ).
 
/*``C++``Fri May 31 10:02:37 MET DST 1996``*/
/* opName(X,Y) */

opName(X,Y) :- $name(X,L), $reverse(L,[D|R]), 
	( $memberchk(35,R) -> strip([D|R],[C|S]); [C|S]=[D|R] ), $reverse([C|S],T),
	( C=:=34 -> ( $reverse(S,[34|B]), $name('operator',A), $append(A,B,Z), $name(Y,Z) );
	( D=:=48 -> ( $name(Y,[126|T]) ); $name(Y,T)) ).

strip([35|L],L) :- !.
strip([_|L],R) :- strip(L,R).
 
/*``C++``Fri May 31 10:02:44 MET DST 1996``*/
/* opType(X,U) */

opType(X,U) :- 
	( isMemberFunction(X,C,U), opName(U,V), (V?=C; $name(V,[126|_])) ) ->
		( true );
		( return(U,'OPERATION',X,_,T,P) -> /* CPP018 */
			(isConst(X,U) -> writeType(X,T,'return_const',P); writeType(X,T,'',P)); 
			write('void ') ).
 
/*``C++``mardi, 15 octobre 1996, 13:23:03 MET``*/
/* opClass(X,U) */

opClass(X,U) :- isMemberFunction(X,C,U),
	write(C), generic(X,C), insertFormalParam2(X,C), fail.
opClass(X,U) :- isMemberFunction(X,C,U) -> write('::'); true.
 
/*``C++``Fri May 31 10:02:56 MET DST 1996``*/
/* EXCEPTIONS */
/*------------*/
 
/*``C++``Fri May 31 10:03:05 MET DST 1996``*/
/* insertEx(X,U) */

insertEx(X,U) :- ifCom, insertCom(U,'EXCEPTION',X,'ExcTxt').
 
/*``C++``Fri May 31 10:03:10 MET DST 1996``*/
/* OBCS */
/*------*/
 
/*``C++``Fri May 31 10:03:16 MET DST 1996``*/
/* insertOBCSSpec(X) */

insertOBCSSpec(X) :- ifCom, insertCom(_,_,X,'ObcsTxt').
 
/*``C++``Fri May 31 10:03:22 MET DST 1996``*/
/* insertOBCSBody(X) */

insertOBCSBody(X) :- ifCom, insertCom(_,_,X,'ObcsBodyTxt').
insertOBCSBody(X) :- ifPseudo, insertPseudo(_,_,X,'Obcs').
 
/*``C++``Fri May 31 10:03:27 MET DST 1996``*/
/* #INCLUDE */
/*---------*/
 
/*``C++``mardi, 15 octobre 1996, 13:30:17 MET``*/
/* withes(X,Y) */

withes(X,Y) :- with(X,Y), $assert(withed(X,Y)).

notToWith(X,Y) :- withed(X,Y); filter(X,Y); isNested(Y,_).

filter(X,Y) :- memezTra(Y,'FORMAL_PARAMETERS'); memezTra(Y,'STANDARD'); 
	Y='NIL'; Y='?'; Y='std'; Y='char';Y='double';Y='int';Y='long';Y='short';Y='unsigned'. /* CPP026 */
 
/*``C++``mardi, 15 octobre 1996, 15:14:17 MET``*/
/* with(X,Y) */

with(X,Y) :- notToWith(X,Y) -> fail; ( 
	( extract(_,_,Y,'spec',F) ->
	( openMakeFile(G), writeFileName(Y,F), sp, closeMakeFile(G),
	  write('#include '), begInc(Y), writeFileName(Y,F), endInc(Y), nl );
	( (ifStd(Y) -> 
		true;
		(openMakeFile(G), writeEnvFileName(Y), sp, closeMakeFile(G))),
	  write('#include '), begInc(Y), writeEnvFileName(Y), endInc(Y), nl ) )   ).

begInc(X) :- ifStd(X) -> write('<'); write('"').
endInc(X) :- ifStd(X) -> write('>'); write('"').
 
