#!/bin/sh
# doc_extractors/html/print.sh
# HTML doc generator (prolog)
# Stood v4.3 - TNI - December 2002

# This file is executed by internalTools/print.sh

# arguments:
# $1 : input file (prolog predicates)
# $2 : this directory

SUFFIX=`cat "$2"/suffix.cfg`
PREDICATS="$1"

SIMPATH="$STOODPRO/modlib":"$STOODPRO/lib":"$STOODPRO/cmplib"
export SIMPATH PREDICATS SUFFIX

echo "=== begin doc generation : `date`"
"$STOODBIN/sbprolog" -m $SBPROLOG_M_SIZE -p $SBPROLOG_P_SIZE "$2/Input.sbp"
mv "$1" `dirname "$1"`/extract.pro
echo "=== end doc generation : `date`"

# when Java applets are used instead of GIF:
# cd "$2"
# cp *.class `dirname "$1"`
