#!/bin/sh
# STOOD v5.0 - TNI Europe - March 2005 -
# check_aadl : syntactic AADL 1.0 analyser.

SECTION="$5"
FILE=`echo "$1" | sed 's/.*\///'`
DIR=`echo "$1" | sed 's/\/[^\/]*$//'`
NAME=`echo "$1" | sed 's/\.[^\.]*$//'`
SUFFIX=`echo "$1" | sed 's/.*\.//'`

if test $SUFFIX = "aadl"
then
  cat $1 | ${STOODBIN}/aadlrev > tmp.pro
  rm tmp.pro
  echo "AADL 1.0 syntactic analysis completed"
else
  echo "not an AADL file"
fi
