#!/bin/sh
# internalTools/copylock.sh
# lock a version with the system configuration manager
# Stood 5.0 - TNI Europe - June 2004

# This file is executed to lock the version within CM space.
# It is called from the menus:
# Design/checkout and Component/checkout.
# echo lock

# arguments:
# echo $1 : current design
# echo $2 : base directory
# echo $3 : version id
# echo $4 : selected component
# echo $5 : lock flag
# echo $6 : filename with the list of components 
# when the property CheckOutWithArgFile is set to Yes
 
if test -z $3
then V=Default
else V=$3
fi

cd $2

if test $1 = $4
then
  if test -d $V/$1
  then
    if test -f $V/$1/StoodCM.lok
    then echo 'version '$3' of design '$1' is already locked'
    else echo locked > $V/$1/StoodCM.lok
    fi
  fi
fi
