#!/bin/sh
# internalTools/cvsin.sh
# checkin to CVS
# Stood v4.3 - TNI - December 2002

# This file is executed when a module is saved.
# echo checkin

# arguments:
# echo $1 : name of design
# echo $2 : base directory of the design
# echo $3 : version id
# echo $4 : selected module
# echo $5 : protection flag

CVSROOT=:ext:tni@popoff:/home/popoff/cvs
export CVSROOT

if test $1 = $4 # Module save or Design save
then
	directoryToSave=$1
else
	directoryToSave=$1/$4
fi

cd $2/$directoryToSave

if test ! $3 == ''
then
	revisionNumber=`echo $3`
	string='revision '$3' of '
else
	revisionNumber=none
fi

echo 'check in '$revision $3' from local space to repository'

cvs -Q import -m "" -I ! -I "CVS" -I "Stood.lok" -k'b' $directoryToSave $1 $revisionNumber
