#!/bin/sh
# internalTools/lock.sh
# lock selected application for current user
# Stood v4.3 - TNI - December 2002
# Stood v5 - TNI - January 2004 (Lock component)

# This file is executed when a design name is selected
# in stood main editor. It creates a file named $1
# explaining why the design $2 is locked.

# arguments :
# $1 : name of lock file to be created
# $2 : name of locked design
# $3 : name of locked component (optional, only if lock component)

if test  $# = 3  
then
	echo "$2 : $3 component is locked by $USER " > "$1"
else
	echo "$2 design is locked by $USER " > "$1"
fi
