----------------------------------
C++ type declaration:
----------------------------------

type_declaration ::=
	class_incomplete_definition;
	typedef type_definition $Tp;

class_incomplete_definition ::=
	class $Tp [ super_class_definition ] "{" [ attributes_definition ] 

super_class_definition ::=
	":" scope $S2

attributes_definition ::=
	[ scope":" ] t1 a1; t2 a2;

scope ::=
	public | private | protected
		
type_definition ::=
	predefined_type_ref
	other_type_ref
	| struct { t1 a1; t2 a2; }
	| enum { e1, e2, e3 }
	| union { t1 v1; t2 v2; }

Notes:
-----
- A HOOD type may be either a C++ class or a typedef.
- This definition should never include any member functions
( these member functions should be defined as HOOD operations ).