The component EHD represents the main application to be developed.
Its black box view shows the EHD within its environment, and only its provided interface is shown.
Its white box view shows the contents of the EHD, in terms of subcomponents and internal connections between them.

This project is a simple example model, based on the following requirements for an Electric Hair Dryer system:
1.      The system shall allow user to select motor speed (off, low, or high). 
2.      The system shall apply power to motor depending on the selected speed setting. 
3.      The system shall cycle the heater (30 seconds on and 30 seconds off) when in low and high speed modes
4.      The system display shall show the selected speed, heater status and the count down time when the heater is on.