--  visibility on required modules : 
with instruments;
use type instruments.Instrument;
with gnat.io;
 use gnat.io;
package body chronometers is
  package io renames gnat.io;
  procedure Display_Value (me : IN Chronometer) is
  	V : Integer;
  begin
  	instruments.Display_Value(instruments.Instrument(me));
  	V := me.Seconds + me.Minutes * 60 + me.Hours * 3600; 
  	Put("<<");
  	Put(Character'Val(Character'Pos('0') + (V / 1000) mod 10));
  	Put(Character'Val(Character'Pos('0') + (V / 100) mod 10));
  	Put(Character'Val(Character'Pos('0') + (V / 10) mod 10));
  	Put(Character'Val(Character'Pos('0') + V mod 10));
  	Put(">>");
  end Display_Value;
end chronometers;
