--  visibility on required modules : 
with gnat.io;
 use gnat.io;
package body clocks is
  package io renames gnat.io;
  procedure Display_Value (me : IN Clock) is
  begin
  	instruments.Display_Value(instruments.Instrument(me));
  	Put(Character'Val(Character'Pos('0') + me.Hours / 10)); 
  	Put(Character'Val(Character'Pos('0') + me.Hours mod 10));
  	Put(":");
  	Put(Character'Val(Character'Pos('0') + me.Minutes / 10));
  	Put(Character'Val(Character'Pos('0') + me.Minutes mod 10));
  	Put(":");
  	Put(Character'Val(Character'Pos('0') + me.Seconds / 10));
  	Put(Character'Val(Character'Pos('0') + me.Seconds mod 10));
  end Display_Value;
  procedure Init (me : IN OUT Clock; H : IN Twenty_Four; M : IN Sixty; S : IN Sixty) is
  begin
  	me.Seconds := S;
  	me.Minutes := M;
  	me.Hours := H;
  end Init;
  procedure Increment (me : IN OUT Clock; Inc : IN Integer := 1) is
  	nInc : Integer;
  begin
  	me.Seconds := (me.Seconds + Inc) mod 60;
  	nInc := (me.Seconds + Inc) / 60;
  	me.Minutes := (me.Minutes + nInc) mod 60;
  	nInc := (me.Minutes + Inc) / 60;
  	me.Hours := (me.Hours + nInc) mod 24;
  end Increment;
end clocks;
