--  visibility on required modules : 
with instruments;
use type instruments.Instrument;
package clocks is
  subtype Sixty is Integer range 0 .. 60;
  subtype Twenty_Four is Integer range 0 .. 24;
  type Clock is new instruments.Instrument with record
  	Seconds : Sixty := 0;
  	Minutes : Sixty := 0;
  	Hours : Twenty_Four := 0;
  end record;
  procedure Display_Value (me : IN Clock);
  procedure Init (me : IN OUT Clock; H : IN Twenty_Four; M : IN Sixty; S : IN Sixty);
  procedure Increment (me : IN OUT Clock; Inc : IN Integer := 1);
end clocks;
