--  visibility on required modules : 
with instruments;
use type instruments.Instrument;
with gnat.io;
 use gnat.io;
package body graphic_gauges is
  package io renames gnat.io;
  procedure Display_Value (me : IN Graphic_Gauge) is
  	Lg : constant Integer := me.Size * me.Value / 100;
  	S1 : constant String (1 .. Lg) := (others => me.Fill);
  	S2 : constant String (Lg + 1 .. me.Size) := (others => me.Empty);
  begin 
  	instruments.Display_Value(instruments.Instrument(me));
  	Put('<');
  	Put(S1);
  	Put(S2);
  	Put('>');
  end Display_Value;
end graphic_gauges;
