--  visibility on required modules : 
with instruments;
use type instruments.Instrument;
with gauges;
use type gauges.Percent;
use type gauges.Gauge;
with clocks;
use type clocks.Sixty;
use type clocks.Twenty_Four;
use type clocks.Clock;
--  visibility on implementing modules : 
with speedometers;
use type speedometers.Speed;
use type speedometers.Speedometer;
with graphic_gauges;
use type graphic_gauges.Graphic_Gauge;
with chronometers;
use type chronometers.Chronometer;
package instr is
  subtype Sixty is clocks.Sixty;
  subtype Twenty_Four is clocks.Twenty_Four;
  type Clock is new clocks.Clock with null record;
  subtype Percent is gauges.Percent;
  type Gauge is new gauges.Gauge with null record;
  subtype Speed is speedometers.Speed;
  type Speedometer is new speedometers.Speedometer with null record;
  type Graphic_Gauge is new graphic_gauges.Graphic_Gauge with null record;
  type Chronometer is new chronometers.Chronometer with null record;
--  Subprogram : Display_Value#2 is inherited from : Clock
--  Subprogram : Init is inherited from : Clock
--  Subprogram : Increment is inherited from : Clock
--  Subprogram : Display_Value#3 is inherited from : Gauge
--  Subprogram : Display_Value#4 is inherited from : Speedometer
--  Subprogram : Display_Value#5 is inherited from : Graphic_Gauge
--  Subprogram : Display_Value#6 is inherited from : Chronometer
end instr;
