// SPEC OF MODULE : arrayedLists
#ifndef INCLUDE_spec_arrayedLists
#define INCLUDE_spec_arrayedLists
// ========== visibility on required modules : 
#include "../../basicClasses/_cpp/basicClasses.h"
class ArrayedListIterator;
// NESTED MODULE : ArrayedList
// ---------- provided types and constants : 
class ArrayedList : public AbstractList
{
private:
	friend class ArrayedListIterator;
	int values[100];
	int size; 
public:
	ArrayedList() : size(0) { };
	virtual void insert(const int d) { values[size++] = d; };
	virtual Iterator &getIterator();
};

// NESTED MODULE : ArrayedListIterator
// ---------- provided types and constants : 
class ArrayedListIterator : public Iterator
{
private:
	ArrayedList* iterated;
	int current;
public:
	ArrayedListIterator(ArrayedList *il) : iterated(il), current(0) { }; 
	int more();
	int next();
};

// END OF MODULE : arrayedLists
#endif
