-- Dining Philosophers - Ada 95 edition
-- 
-- Society gives unique ID's to people, and register their names.
-- 
-- Michael B. Feldman, The George Washington University, July 1995.
-- HOOD version by Pierre Dissaux, TNI, June 1998.


--  required interface : 
--   Required OPERATION : NONE
--   Required EXCEPTION : NONE
--   Required TYPE :
--     TYPE : Positive of object : standard
--     TYPE : String of object : standard
--   Required CONSTANT : NONE
--   Required DATA : NONE

--  visibility on required modules : 

package society is

  subtype Unique_DNA_Codes is Positive range 1..5;

  function get_name (
    Code : IN Unique_DNA_Codes)
     return String;

end society;
