-- Simple integer pseudo-random nimber generator package.
-- 
-- From Michael B. Feldman, The George Washington University, June 1995.
-- HOOD version by Pierre Dissaux, TNI, June 1998.


--  visibility on required modules : 
with Ada.Numerics.Discrete_Random;


package body random_generic is

  generic package discrete_random renames Ada.Numerics.Discrete_Random;
  package Ada95_Random is new discrete_random
  	(Result_Subtype => Result_Subtype);
  G : Ada95_Random.Generator;

  function Random_Value
     return Result_Subtype is
  begin
  	return Ada95_Random.Random(Gen => G);
  end Random_Value;

begin
	Ada95_Random.Reset(Gen => G);

end random_generic;
