

--  visibility on required modules : 

with ada.text_io;

package body counter is

  package text_io renames ada.text_io;
  procedure set (me : IN OUT counter; rep : IN counter_colour) is
  begin
    me.colour := rep;
  end set;

  procedure display (me : IN counter) is
  begin
    case me.colour is
      when BLACK => text_io.put('X');
      when WHITE => text_io.put('O');
    end case;
  end display;

  procedure display_none (me : IN counter) is
  begin
    text_io.put(' ');
  end display_none;

  procedure flip (me : IN OUT counter) is
  begin
    case me.colour is
      when BLACK => me.colour := WHITE;
      when WHITE => me.colour := BLACK;
    end case;
  end flip;

  function rep (me : IN counter) return counter_colour is
  begin
    return me.colour;
  end rep;


end counter;
