

--  visibility on required modules : 
with counter;
use type counter.counter;
use type counter.counter_colour;
with board;
use type board.state_of_game;

package player is

  type player is tagged 
  record 
    plays_with : counter.counter;
  end record;

  procedure set (me : IN OUT player; c : IN counter.counter_colour);

  procedure get_move (me : IN player; row : OUT integer; column : OUT integer);

  function my_counter (me : IN player) return counter.counter;

  procedure announce (me : IN player; what : IN board.state_of_game);

end player;
