--  visibility on required modules : 
package body data_logger is
  procedure OPCS_co_log (reading : IN co_reading) is
  begin
    null;
  end OPCS_co_log;
  procedure OPCS_ch4_log (reading : IN ch4_reading) is
  begin
    null;
  end OPCS_ch4_log;
  procedure OPCS_air_flow_log (reading : IN air_flow_reading) is
  begin
    null;
  end OPCS_air_flow_log;
  procedure OPCS_high_low_water_log (reading : IN water_mark) is
  begin
    null;
  end OPCS_high_low_water_log;
  procedure OPCS_water_flow_log (reading : IN boolean) is
  begin
    null;
  end OPCS_water_flow_log;
  procedure OPCS_motor_log (status : IN motor_state_changes) is
  begin
    null;
  end OPCS_motor_log;
  task body OBCS is
    co_log_reading : co_reading;
    ch4_log_reading : ch4_reading;
    air_flow_log_reading : air_flow_reading;
    high_low_water_log_reading : water_mark;
    water_flow_log_reading : boolean;
    motor_log_status : motor_state_changes;
  begin
    loop
      select
        -- ASER
        accept co_log (reading : IN co_reading) do
          co_log_reading := reading;
        end co_log;
        begin
          OPCS_co_log (co_log_reading );
        exception
          when others =>
            raise;
        end;
      or
        -- ASER
        accept ch4_log (reading : IN ch4_reading) do
          ch4_log_reading := reading;
        end ch4_log;
        begin
          OPCS_ch4_log (ch4_log_reading );
        exception
          when others =>
            raise;
        end;
      or
        -- ASER
        accept air_flow_log (reading : IN air_flow_reading) do
          air_flow_log_reading := reading;
        end air_flow_log;
        begin
          OPCS_air_flow_log (air_flow_log_reading );
        exception
          when others =>
            raise;
        end;
      or
        -- ASER
        accept high_low_water_log (reading : IN water_mark) do
          high_low_water_log_reading := reading;
        end high_low_water_log;
        begin
          OPCS_high_low_water_log (high_low_water_log_reading );
        exception
          when others =>
            raise;
        end;
      or
        -- ASER
        accept water_flow_log (reading : IN boolean) do
          water_flow_log_reading := reading;
        end water_flow_log;
        begin
          OPCS_water_flow_log (water_flow_log_reading );
        exception
          when others =>
            raise;
        end;
      or
        -- ASER
        accept motor_log (status : IN motor_state_changes) do
          motor_log_status := status;
        end motor_log;
        begin
          OPCS_motor_log (motor_log_status );
        exception
          when others =>
            raise;
        end;
      or
        terminate;
      end select;
    end loop;
  end OBCS;
end data_logger;
