--  visibility on required modules : 
--  visibility on implementing modules : 
with ch4_status;
use type ch4_status.methane_status;
with ch4_sensor;
use type ch4_sensor.ch4_reading;
with air_flow_sensor;
use type air_flow_sensor.air_flow_status;
with co_sensor;
use type co_sensor.co_reading;
--  visibility on real_time attributes : 
with environment_monitor_RTATT;
package environment_monitor is
  subtype ch4_reading is ch4_sensor.ch4_reading;
  subtype air_flow_status is air_flow_sensor.air_flow_status;
  subtype methane_status is ch4_status.methane_status;
  subtype co_reading is co_sensor.co_reading;
  ch4_high : constant ch4_reading := ch4_reading(ch4_sensor.ch4_high);
  co_high : constant co_reading := co_reading(co_sensor.co_high);
  function check_safe return methane_status renames ch4_status.read;
end environment_monitor;
