with SYSTEM; use SYSTEM;
with RTA; use RTA;
with Ada.Real_Time; use Ada.Real_Time;
package hlw_handler_RTATT is
  start : constant array(SYSTEM_WIDE_MODE) of OPERATION_ATTRIBUTES := 
    ( others => ( 
      BUDGET => To_Time_Span(0.0),
      WCET => To_Time_Span(0.0) ) );
  initialise : constant array(SYSTEM_WIDE_MODE) of OPERATION_ATTRIBUTES := 
    ( others => ( 
      BUDGET => To_Time_Span(0.0),
      WCET => To_Time_Span(0.0) ) );
  CEILING : constant array(SYSTEM_WIDE_MODE) of PRIORITY := 
    ( others => 0 );
  INITIAL_CEILING_PRIORITY : constant PRIORITY := CEILING(START_MODE);
  THREAD : constant array(SYSTEM_WIDE_MODE) of THREAD_ATTRIBUTES := 
    ( others => ( 
      PRI => 6,
      TRANS => To_Time_Span(0.0),
      IMP => soft,
      DEADLINE => To_Time_Span(200.000000),
      BUDGET => To_Time_Span(0.0),
      WCET => To_Time_Span(20.000000) ) );
  INITIAL_THREAD_PRIORITY : constant PRIORITY := THREAD(START_MODE).PRI;
  MAT : constant array(SYSTEM_WIDE_MODE) of TIME_SPAN := 
    ( others => To_Time_Span(6000.000000) );
  MAF : constant array(SYSTEM_WIDE_MODE) of FREQUENCY := 
    ( others => ( 
      NUMBER => 1,
      IN_PERIOD => To_Time_Span(6000.000000) ) );
end hlw_handler_RTATT;
