--  visibility on required modules : 
with device_register;
use type device_register.csr;
with system;
use type system.Address;
package body motor is
  motor_state : pump_status := Off;
  return_condition : pump_status := Off;
  pcsr : device_register.csr :=
    (Error_Bit => Clear,
     Operation => Set,
     Done => False,
     Interrupt => I_Enabled,
     Device => D_Enabled);
  for pcsr'address use 16#AA14#;
  procedure OPCS_not_safe is
  begin
    null;
  end OPCS_not_safe;
  procedure OPCS_is_safe is
  begin
    null;
  end OPCS_is_safe;
  function OPCS_request_status return pump_status is
    void : pump_status;
  begin
    return void;
  end OPCS_request_status;
  procedure OPCS_set_pump (status : IN pump_status) is
  begin
    null;
  end OPCS_set_pump;
  protected body OBCS is
    procedure not_safe is
    begin
      OPCS_not_safe;
    end not_safe;
    procedure is_safe is
    begin
      OPCS_is_safe;
    end is_safe;
    function request_status return pump_status is
    begin
      return OPCS_request_status;
    end request_status;
    procedure set_pump (status : IN pump_status) is
    begin
      OPCS_set_pump (status );
    end set_pump;
  end OBCS;
end motor;
