--  visibility on required modules : 
with system;
 use system;
with ada.real_time;
 use ada.real_time;
package rta is
  package real_time renames ada.real_time;
  type SYSTEM_WIDE_MODE is range 1 .. 10;
  type IMPORTANCE is (
    HARD,
    SOFT,
    BACKGROUND);
  type OPERATION_ATTRIBUTES is 
  record 
    BUDGET : TIME_SPAN;
    WCET : TIME_SPAN;
  end record;
  type THREAD_ATTRIBUTES is 
  record 
    PRI : PRIORITY;
    TRANS : TIME_SPAN;
    IMP : IMPORTANCE;
    DEADLINE : TIME_SPAN;
    BUDGET : TIME_SPAN;
    WCET : TIME_SPAN;
  end record;
  type FREQUENCY is 
  record 
    NUMBER : POSITIVE;
    IN_PERIOD : TIME_SPAN;
  end record;
  DEFAULT_PRIORITY : constant PRIORITY := 1;
  START_MODE : constant SYSTEM_WIDE_MODE := 1;
  CURRENT_MODE : SYSTEM_WIDE_MODE;
  SYSTEM_START_UP_TIME : constant TIME := CLOCK;
end rta;
