# include "builtin.h"
# include <stdio.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
extern FILE *curr_in, *curr_out;
# define yyin curr_in
# define yyout curr_out
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
# define YYNEWLINE 10

/****************** SCAN_ADA **************************/
b_SCAN_ADA(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
					ada_identifier();
break;
case 2:
							dot();
break;
case 3:
					;
break;
case 4:
				anything();
break;
case 5:
							anything();
break;
case 6:
		anything();
break;
case 7:
					;
break;
case 8:
							anything();
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }

int ada_IgnoreCase = 1;
char *ada_ReservedWordList[] = {
	"abort", "abs", "accept", "access", "all", "and", "array", "at", "begin", "body",
	"case", "constant", "declare", "delay", "delta", "digits", "do", "else", "elsif",
	"end", "entry", "exception", "exit", "for", "function", "generic", "goto", "if",
	"in", "is", "limited", "loop", "mod", "new", "not", "null", "of", "or", "others",
	"out", "package", "pragma", "private", "procedure", "raise", "range",
	"record", "rem", "renames", "return", "reverse", "select", "separate",
	"subtype", "task", "terminate", "then", "type", "use", "when", "while",
	"with", "xor",
0};
 
/************************ SCAN_C ******************/
b_SCAN_C(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
                                        c_identifier();
break;
case 2:
                                                        dot();
break;
case 3:
                        anything();
break;
case 4:
                        anything();
break;
case 5:
                anything();
break;

case 6:
                                anything();
break;
case 7:
                                                        anything();

break;
case 8:
	;
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }

int c_IgnoreCase = 0;
char *c_ReservedWordList[] = {
        "void", "auto", "static", "extern", "register", "typedef",
        "char", "float", "double", "int", "short", "long", "unsigned", "struct",
	"union", "enum", "return", "goto",
        "if", "else", "while", "do", "for", "switch", "break", "continue",
        "case", "default", "sizeof",
0};

/********************** SCAN_CPP ******************/
b_SCAN_CPP(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
                                        cpp_identifier();
break;
case 2:
                                                        dot();
break;
case 3:
                                                        dot();
break;
case 4:
                                        ;
break;
case 5:
                        anything();
break;
case 6:
                        anything();
break;
case 7:
                ;
break;
case 8:
                                ;
break;
case 9:
                                anything();
break;
case 10:
                                                        anything();
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }

int cpp_IgnoreCase = 0;
char *cpp_ReservedWordList[] = {

        "void", "auto", "static", "extern", "register", "typedef", "struct",
	"union", "enum",
        "char", "float", "double", "int", "short", "long", "unsigned",
        "if", "else", "while", "do", "for", "switch", "break", "continue",
	"return", "goto", "case", "default", "sizeof",

        "asm", "class", "const", "delete", "friend", "inline",
        "new", "operator", "overload", "public", "private", "protected",
        "this", "virtual",

0};
  
/**********************************************************
	this code is no more independant of the langage :
**********************************************************/

int State = 0;

ada_identifier()
{
	static int BoL = 1;

	if(is_ada_Reserved(yytext)) {
		State = 0;
		return;
	}
	if (State == 2) {
		printf(" ");
	} else {
		if (!BoL) {printf("\n"); BoL = 1;}
	}
	printf("%s", yytext);
	BoL = 0;
	State = (State == 2) ? 0 : 1;
}

c_identifier()
{
        static int BoL = 1;

        if(is_c_Reserved(yytext)) {
                State = 0;
                return;
        }
        if (State == 2) {
                printf(" ");
        } else {
                if (!BoL) {printf("\n"); BoL = 1;}
        }
        printf("%s", yytext);
        BoL = 0;
        State = (State == 2) ? 0 : 1;
}

cpp_identifier()
{
        static int BoL = 1;

        if(is_cpp_Reserved(yytext)) {
                State = 0;
                return;
        }
        if (State == 2) {
                printf(" ");
        } else {
                if (!BoL) {printf("\n"); BoL = 1;}
        }
        printf("%s", yytext);
        BoL = 0;
        State = (State == 2) ? 0 : 1;
}

dot()
{
	State = (State == 1) ? 2 : 0;
}

anything()
{
	State = 0;
}

int is_ada_Reserved(word)
char *word;
{
	int i = ada_IgnoreCase;
	char **p = ada_ReservedWordList;
	while (*p) {
		if (stringCompare(word, *p, i)) return 1;
		p++;
	}
	return 0;
}

int is_c_Reserved(word)
char *word;
{
	int i = c_IgnoreCase;
        char **p = c_ReservedWordList;
        while (*p) {
                if (stringCompare(word, *p, i)) return 1;
                p++;
        }
        return 0;
}

int is_cpp_Reserved(word)
char *word;
{
	int i = cpp_IgnoreCase;
        char **p = cpp_ReservedWordList;
        while (*p) {
                if (stringCompare(word, *p, i)) return 1;
                p++;
        }
        return 0;
}

int stringCompare(s1, s2, i)
char *s1, *s2;
int i;
{
	do {
		register char c1 = *(s1++);
		register char c2 = *(s2++);
		if (c1 == 0) return (c2 == 0);
		if (c2 == 0) return (c1 == 0);
		if (i) {
		  if ('A' <= c1 && c1 <= 'Z' ) c1 += ('a' - 'A');
		  if ('A' <= c2 && c2 <= 'Z' ) c2 += ('a' - 'A');
		  }
		else {
		  if (c1 != c2) return (0);
		  }
	} while (1);
}

int yywrap()
{
	return 1;
}
	
int yyvstop[] = {
0,

8,
0,

3,
8,
0,

3,
0,

8,
0,

8,
0,

8,
0,

2,
8,
0,

1,
8,
0,

4,
0,

1,
0,

5,
0,

6,
0,

7,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
6,11,	0,0,	1,4,	1,5,	
7,13,	4,5,	4,5,	0,0,	
6,11,	6,11,	0,0,	0,0,	
7,13,	7,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,6,	
4,5,	0,0,	0,0,	0,0,	
1,7,	6,12,	0,0,	0,0,	
2,7,	7,13,	1,8,	1,9,	
8,15,	1,3,	2,8,	2,9,	
0,0,	0,0,	0,0,	6,11,	
0,0,	0,0,	0,0,	7,13,	
12,11,	0,0,	0,0,	0,0,	
13,18,	0,0,	1,10,	0,0,	
0,0,	0,0,	0,0,	0,0,	
6,11,	0,0,	0,0,	0,0,	
7,14,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
0,0,	0,0,	0,0,	0,0,	
10,17,	0,0,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
10,16,	10,16,	10,16,	10,16,	
14,18,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
14,19,	14,19,	14,19,	14,19,	
15,15,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
15,15,	15,20,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	15,15,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	15,15,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
15,15,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	17,16,	
17,16,	17,16,	17,16,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	0,0,	0,0,	
0,0,	0,0,	19,21,	0,0,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	21,19,	21,19,	21,19,	
21,19,	0,0,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-5,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+4,	0,		yyvstop+3,
yycrank+0,	yysvec+4,	yyvstop+6,
yycrank+-7,	0,		yyvstop+8,
yycrank+-11,	0,		yyvstop+10,
yycrank+3,	0,		yyvstop+12,
yycrank+0,	0,		yyvstop+14,
yycrank+29,	0,		yyvstop+17,
yycrank+0,	yysvec+6,	0,	
yycrank+26,	0,		yyvstop+20,
yycrank+25,	0,		0,	
yycrank+113,	0,		0,	
yycrank+-235,	0,		0,	
yycrank+0,	yysvec+10,	yyvstop+22,
yycrank+236,	0,		0,	
yycrank+0,	0,		yyvstop+24,
yycrank+311,	0,		yyvstop+26,
yycrank+0,	0,		yyvstop+28,
yycrank+386,	0,		0,	
0,	0,	0};
struct yywork *yytop = yycrank+508;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
